import { VfField, Column, LabelField, LabelPreset } from '../interfaces/table';

interface Props {
    modelValue: Column[];
    labels?: LabelField[];
    vfFields: VfField[];
    actions: VfField[];
    icons: VfField[];
    height?: number;
    disabled?: boolean;
    labelPresets?: LabelPreset[];
}
declare const _default: import('vue').DefineComponent<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
    disabled: boolean;
    height: number;
    labelPresets: () => never[];
    labels: () => never[];
    actions: () => never[];
    icons: () => never[];
    vfFields: () => never[];
}>, {}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    "update:modelValue": (columnEdit: Column[]) => void;
    "update:labels": (labels: LabelField[]) => void;
    error: (s: string) => void;
}, string, import("vue").PublicProps, Readonly<import("vue").ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
    disabled: boolean;
    height: number;
    labelPresets: () => never[];
    labels: () => never[];
    actions: () => never[];
    icons: () => never[];
    vfFields: () => never[];
}>>> & {
    onError?: ((s: string) => any) | undefined;
    "onUpdate:modelValue"?: ((columnEdit: Column[]) => any) | undefined;
    "onUpdate:labels"?: ((labels: LabelField[]) => any) | undefined;
}, {
    labels: LabelField[];
    height: number;
    disabled: boolean;
    actions: VfField[];
    vfFields: VfField[];
    icons: VfField[];
    labelPresets: LabelPreset[];
}, {}>;
export default _default;
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: import('vue').PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: import('vue').PropType<T[K]>;
        required: true;
    };
};
type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? __VLS_Prettify<P[K] & {
        default: D[K];
    }> : P[K];
};
type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};
