import { defineComponent as bt, ref as ue, onMounted as yt, onBeforeUnmount as qt, computed as z, openBlock as I, createElementBlock as M, normalizeClass as q, normalizeStyle as Re, createElementVNode as p, Fragment as te, renderList as ne, toDisplayString as ge, renderSlot as gn, createTextVNode as lt, h as Xn, resolveComponent as Xo, useCssVars as qo, useSlots as Go, toRefs as mo, watch as vt, watchEffect as qn, unref as ee, withKeys as Jo, createVNode as ze, Transition as Ko, withCtx as It, withDirectives as fe, createBlock as Qo, createCommentVNode as Vt, vShow as bo, reactive as Zo, nextTick as yo, isRef as er, vModelText as ke, pushScopeId as xn, popScopeId as Sn, withModifiers as tr, vModelSelect as Gn } from "vue";
var A = /* @__PURE__ */ ((t) => (t.DATA = "DATA", t.SYMBOL = "SYMBOL", t.ACTION = "ACTION", t.ICON = "ICON", t.LABEL = "LABEL", t))(A || {});
const mn = [
  {
    vfTitle: "⌴",
    vfCode: "space",
    vfType: A.SYMBOL,
    vfAcutalField: "space",
    vfActualFieldTitle: "Dấu cách",
    value: "&nbsp;"
  },
  {
    vfTitle: "↩",
    vfCode: "newline",
    vfType: A.SYMBOL,
    vfAcutalField: "newline",
    vfActualFieldTitle: "NewLine",
    value: "<br/>"
  },
  {
    vfTitle: "-",
    vfCode: "minus",
    vfType: A.SYMBOL,
    vfAcutalField: "minus",
    vfActualFieldTitle: "Dấu trừ",
    value: "&hyphen;"
  },
  {
    vfTitle: "_",
    vfCode: "underscore",
    vfType: A.SYMBOL,
    vfAcutalField: "underscore",
    vfActualFieldTitle: "Dấu gạch dưới",
    value: "_"
  },
  {
    vfTitle: "|",
    vfCode: "vertical",
    vfType: A.SYMBOL,
    vfAcutalField: "vertical",
    vfActualFieldTitle: "Dấu dọc",
    value: "|"
  },
  {
    vfTitle: ",",
    vfCode: "comma",
    vfType: A.SYMBOL,
    vfAcutalField: "comma",
    vfActualFieldTitle: "Dấu phẩy",
    value: ","
  },
  {
    vfTitle: ":",
    vfCode: "colon",
    vfType: A.SYMBOL,
    vfAcutalField: "colon",
    vfActualFieldTitle: "Hai chấm",
    value: ":"
  },
  {
    vfTitle: ".",
    vfCode: "dot",
    vfType: A.SYMBOL,
    vfAcutalField: "dot",
    vfActualFieldTitle: "Dấu chấm",
    value: "."
  },
  {
    vfTitle: ";",
    vfCode: "semicolon",
    vfType: A.SYMBOL,
    vfAcutalField: "semicolon",
    vfActualFieldTitle: "Chấm phẩy",
    value: ";"
  },
  {
    vfTitle: "/",
    vfCode: "slash",
    vfType: A.SYMBOL,
    vfAcutalField: "slash",
    vfActualFieldTitle: "Dấu gạch chéo",
    value: "/"
  },
  {
    vfTitle: "\\",
    vfCode: "backslash",
    vfType: A.SYMBOL,
    vfAcutalField: "backslash",
    vfActualFieldTitle: "Dấu gạch chéo ngược",
    value: "\\"
  },
  {
    vfTitle: "?",
    vfCode: "question",
    vfType: A.SYMBOL,
    vfAcutalField: "question",
    vfActualFieldTitle: "Dấu hỏi",
    value: "?"
  },
  {
    vfTitle: "~",
    vfCode: "tilde",
    vfType: A.SYMBOL,
    vfAcutalField: "tilde",
    vfActualFieldTitle: "Dấu ngã",
    value: "~"
  },
  {
    vfTitle: "@",
    vfCode: "at",
    vfType: A.SYMBOL,
    vfAcutalField: "at",
    vfActualFieldTitle: "Dấu @",
    value: "@"
  },
  {
    vfTitle: "#",
    vfCode: "hash",
    vfType: A.SYMBOL,
    vfAcutalField: "hash",
    vfActualFieldTitle: "Dấu #",
    value: "#"
  },
  {
    vfTitle: "$",
    vfCode: "dollar",
    vfType: A.SYMBOL,
    vfAcutalField: "dollar",
    vfActualFieldTitle: "Dấu $",
    value: "$"
  },
  {
    vfTitle: "^",
    vfCode: "caret",
    vfType: A.SYMBOL,
    vfAcutalField: "caret",
    vfActualFieldTitle: "Dấu mũ",
    value: "^"
  },
  {
    vfTitle: "&",
    vfCode: "ampersand",
    vfType: A.SYMBOL,
    vfAcutalField: "ampersand",
    vfActualFieldTitle: "Dấu &",
    value: "&"
  },
  {
    vfTitle: "*",
    vfCode: "asterisk",
    vfType: A.SYMBOL,
    vfAcutalField: "asterisk",
    vfActualFieldTitle: "Dấu *",
    value: "*"
  },
  {
    vfTitle: "[",
    vfCode: "openBracket",
    vfType: A.SYMBOL,
    vfAcutalField: "openBracket",
    vfActualFieldTitle: "Mở ngoặc vuông",
    value: "["
  },
  {
    vfTitle: "]",
    vfCode: "closeBracket",
    vfType: A.SYMBOL,
    vfAcutalField: "closeBracket",
    vfActualFieldTitle: "Đóng ngoặc vuông",
    value: "]"
  },
  {
    vfTitle: "(",
    vfCode: "openRoundBracket",
    vfType: A.SYMBOL,
    vfAcutalField: "openRoundBracket",
    vfActualFieldTitle: "Mở ngoặc tròn",
    value: "("
  },
  {
    vfTitle: ")",
    vfCode: "closeRoundBracket",
    vfType: A.SYMBOL,
    vfAcutalField: "closeRoundBracket",
    vfActualFieldTitle: "Đóng hoặc tròn",
    value: ")"
  },
  {
    vfTitle: "<",
    vfCode: "openAngleBracket",
    vfType: A.SYMBOL,
    vfAcutalField: "openAngleBracket",
    vfActualFieldTitle: "Mở ngoặc nhọn",
    value: "&lt;"
  },
  {
    vfTitle: ">",
    vfCode: "closeAngleBracket",
    vfType: A.SYMBOL,
    vfAcutalField: "closeAngleBracket",
    vfActualFieldTitle: "Đóng ngoặc nhọn",
    value: "&gt;"
  },
  {
    vfTitle: '"',
    vfCode: "doubleQuote",
    vfType: A.SYMBOL,
    vfAcutalField: "doubleQuote",
    vfActualFieldTitle: "Dấu ngoặc kép",
    value: '"'
  },
  {
    vfTitle: "'",
    vfCode: "singleQuote",
    vfType: A.SYMBOL,
    vfAcutalField: "singleQuote",
    vfActualFieldTitle: "Dấu ngoặc đơn",
    value: "'"
  },
  {
    vfTitle: "`",
    vfCode: "backtick",
    vfType: A.SYMBOL,
    vfAcutalField: "backtick",
    vfActualFieldTitle: "Dấu ngoặc ngược",
    value: "`"
  },
  {
    vfTitle: "€",
    vfCode: "euro",
    vfType: A.SYMBOL,
    vfAcutalField: "euro",
    vfActualFieldTitle: "Euro",
    value: "€"
  },
  {
    vfTitle: "£",
    vfCode: "pound",
    vfType: A.SYMBOL,
    vfAcutalField: "pound",
    vfActualFieldTitle: "Pound",
    value: "£"
  },
  {
    vfTitle: "¥",
    vfCode: "yen",
    vfType: A.SYMBOL,
    vfAcutalField: "yen",
    vfActualFieldTitle: "Yen",
    value: "¥"
  },
  {
    vfTitle: "¢",
    vfCode: "cent",
    vfType: A.SYMBOL,
    vfAcutalField: "cent",
    vfActualFieldTitle: "Cent",
    value: "¢"
  },
  {
    vfTitle: "©",
    vfCode: "copyright",
    vfType: A.SYMBOL,
    vfAcutalField: "copyright",
    vfActualFieldTitle: "Copyright",
    value: "©"
  },
  {
    vfTitle: "®",
    vfCode: "registered",
    vfType: A.SYMBOL,
    vfAcutalField: "registered",
    vfActualFieldTitle: "Registered",
    value: "®"
  },
  {
    vfTitle: "™",
    vfCode: "trademark",
    vfType: A.SYMBOL,
    vfAcutalField: "trademark",
    vfActualFieldTitle: "Trademark",
    value: "™"
  },
  {
    vfTitle: "§",
    vfCode: "section",
    vfType: A.SYMBOL,
    vfAcutalField: "section",
    vfActualFieldTitle: "Section",
    value: "§"
  },
  {
    vfTitle: "¶",
    vfCode: "paragraph",
    vfType: A.SYMBOL,
    vfAcutalField: "paragraph",
    vfActualFieldTitle: "Paragraph",
    value: "¶"
  },
  {
    vfTitle: "°",
    vfCode: "degree",
    vfType: A.SYMBOL,
    vfAcutalField: "degree",
    vfActualFieldTitle: "Degree",
    value: "°"
  },
  {
    vfTitle: "±",
    vfCode: "plusMinus",
    vfType: A.SYMBOL,
    vfAcutalField: "plusMinus",
    vfActualFieldTitle: "Plus Minus",
    value: "±"
  },
  {
    vfTitle: "×",
    vfCode: "multiply",
    vfType: A.SYMBOL,
    vfAcutalField: "multiply",
    vfActualFieldTitle: "Multiply",
    value: "×"
  },
  {
    vfTitle: "÷",
    vfCode: "divide",
    vfType: A.SYMBOL,
    vfAcutalField: "divide",
    vfActualFieldTitle: "Divide",
    value: "÷"
  },
  {
    vfTitle: "≠",
    vfCode: "notEqual",
    vfType: A.SYMBOL,
    vfAcutalField: "notEqual",
    vfActualFieldTitle: "Not Equal",
    value: "≠"
  },
  {
    vfTitle: "≤",
    vfCode: "lessThanOrEqual",
    vfType: A.SYMBOL,
    vfAcutalField: "lessThanOrEqual",
    vfActualFieldTitle: "Less Than Or Equal",
    value: "≤"
  },
  {
    vfTitle: "≥",
    vfCode: "greaterThanOrEqual",
    vfType: A.SYMBOL,
    vfAcutalField: "greaterThanOrEqual",
    vfActualFieldTitle: "Greater Than Or Equal",
    value: "≥"
  },
  {
    vfTitle: "≈",
    vfCode: "approximatelyEqual",
    vfType: A.SYMBOL,
    vfAcutalField: "approximatelyEqual",
    vfActualFieldTitle: "Approximately Equal",
    value: "≈"
  }
];
A.ACTION, A.ACTION, A.ACTION;
function nr(t) {
  return t && t.__esModule && Object.prototype.hasOwnProperty.call(t, "default") ? t.default : t;
}
/*!
 * escape-html
 * Copyright(c) 2012-2013 TJ Holowaychuk
 * Copyright(c) 2015 Andreas Lubbe
 * Copyright(c) 2015 Tiancheng "Timothy" Gu
 * MIT Licensed
 */
var or = /["'&<>]/, rr = ir;
function ir(t) {
  var e = "" + t, n = or.exec(e);
  if (!n)
    return e;
  var o, r = "", i = 0, a = 0;
  for (i = n.index; i < e.length; i++) {
    switch (e.charCodeAt(i)) {
      case 34:
        o = "&quot;";
        break;
      case 38:
        o = "&amp;";
        break;
      case 39:
        o = "&#39;";
        break;
      case 60:
        o = "&lt;";
        break;
      case 62:
        o = "&gt;";
        break;
      default:
        continue;
    }
    a !== i && (r += e.substring(a, i)), a = i + 1, r += o;
  }
  return a !== i ? r + e.substring(a, i) : r;
}
const en = /* @__PURE__ */ nr(rr), ar = { class: "dynamic-table" }, lr = ["innerHTML"], sr = { key: 1 }, ur = ["colspan"], cr = "tdac", dr = /* @__PURE__ */ bt({
  __name: "DynamicTable",
  props: {
    columns: { default: () => [] },
    templates: { default: () => [] },
    labels: { default: () => [] },
    data: { default: () => [] },
    height: {},
    fixed: { type: Boolean, default: !1 }
  },
  emits: ["onCta"],
  setup(t, { emit: e }) {
    const n = t, o = e, r = ue("");
    yt(() => {
      r.value = `${cr}${Math.floor(Math.random() * 1e6)}`;
      const u = window;
      u[r.value] = function(b, y) {
        const h = n.data[y];
        h && o("onCta", b, h, y);
      };
    }), qt(() => {
      const u = window;
      u[r.value] && (u[r.value] = void 0, delete u[r.value]);
    });
    const i = z(() => (u, b = "", y = {}) => {
      for (const h in u)
        if (u.hasOwnProperty(h)) {
          const g = b ? `${b}.${h}` : h;
          typeof u[h] == "object" && u[h] !== null ? i.value(u[h], g, y) : y[g] = u[h];
        }
      return y;
    }), a = (u, b) => u.replace(/\{\{(.*?)\}\}/g, (y, h) => {
      const g = b[h];
      return g ?? y;
    }), l = z(() => (u) => {
      const b = {
        "text-align": u.align || "left",
        "vertical-align": u.vAlign || "top"
      };
      return u.width && (b.width = u.width), u.minWidth && (b["min-width"] = u.minWidth), u.maxWidth && (b["max-width"] = u.maxWidth), b;
    }), s = z(() => [
      ...n.templates,
      ...n.labels.map((u) => ({
        vfTitle: u.title,
        vfCode: u.code,
        vfType: A.LABEL,
        meta: u.style
      })),
      ...mn
    ].reduce((u, b) => (u[b.vfCode] = b, u), {})), c = z(() => (u) => {
      const b = n.labels.find((g) => g.code === u.vfCode), y = (b == null ? void 0 : b.style) || {}, h = Object.entries(y).map(([g, f]) => `${g.replace(/[A-Z]/g, (x) => `-${x.toLowerCase()}`)}: ${f}`);
      return y.backgroundColor && y.backgroundColor !== "transparent" && (h.push("padding: 0 3px"), h.push("border-radius: 3px")), h.join(";");
    }), d = z(() => (u, b, y) => {
      const h = [];
      for (const g of b.fieldCodes) {
        const f = s.value[g];
        if (f)
          switch (f.vfType) {
            case A.SYMBOL:
              h.push((f == null ? void 0 : f.value) || "");
              break;
            case A.ACTION:
              if (f.vfRenderFunc) {
                const m = f.vfRenderFunc(u, f, y, r.value), C = document.createElement("span");
                C.classList.add("btn"), C.classList.add(`btn-${f.vfCode}`), C.setAttribute("onClick", `${r.value}('${f.vfCode}', ${y})`), C.textContent = m, h.push(C.outerHTML);
                break;
              }
              if (f.vfAcutalField) {
                const C = i.value(u)[(f == null ? void 0 : f.vfAcutalField) || ""], v = document.createElement("span");
                v.classList.add("btn"), v.classList.add(`btn-${f.vfCode}`), v.setAttribute("onClick", `${r.value}('${f.vfCode}', ${y})`), v.textContent = C || "", h.push(v.outerHTML);
                break;
              }
              const D = document.createElement("span");
              D.classList.add("btn"), D.classList.add(`btn-${f.vfCode}`), D.setAttribute("onClick", `${r.value}('${f.vfCode}', ${y})`), D.textContent = (f == null ? void 0 : f.vfTitle) || "", h.push(D.outerHTML);
              break;
            case A.ICON:
              const x = document.createElement("img");
              x.classList.add("icon"), x.src = f.value || "", h.push(x.outerHTML);
              break;
            case A.LABEL:
              const w = document.createElement("span");
              w.style.cssText = c.value(f), w.textContent = f.vfTitle, h.push(w.outerHTML);
              break;
            default:
              let S = i.value(u)[(f == null ? void 0 : f.vfAcutalField) || ""];
              if (f.vfRenderFunc) {
                const m = f.vfRenderFunc(u, f, y, r.value, structuredClone(S));
                h.push(m);
                break;
              }
              const F = u[f.vfAcutalField];
              if (Array.isArray(F)) {
                const m = f.templateShow ? F.map((C) => a(f.templateShow, { $item: en(C) })).join("") : F.join(", ");
                h.push(m);
                break;
              }
              f != null && f.enum && Object.keys(f.enum).length > 0 && (S = f.enum[S] || S, S = en(S)), f != null && f.templateShow && (S = a(f == null ? void 0 : f.templateShow, { value: en(S) })), h.push(S);
              break;
          }
      }
      return h.join("");
    });
    return (u, b) => {
      var y;
      return I(), M("div", {
        class: q(["wrapper-table custom-scroll", { fixed: u.fixed }]),
        style: Re({ height: u.fixed ? `${u.height}px` : "auto" })
      }, [
        p("table", ar, [
          p("thead", null, [
            p("tr", null, [
              (I(!0), M(te, null, ne(u.columns, (h, g) => (I(), M("th", {
                key: g,
                class: q({ "drag-over": h.isDrag })
              }, ge(h.title), 3))), 128))
            ])
          ]),
          p("tbody", null, [
            (((y = u.data) == null ? void 0 : y.length) || 0) > 0 ? (I(!0), M(te, { key: 0 }, ne(u.data, (h, g) => (I(), M("tr", { key: g }, [
              (I(!0), M(te, null, ne(u.columns, (f, D) => (I(), M("td", {
                key: D,
                class: q({ "drag-over": f.isDrag }),
                style: Re(l.value(f))
              }, [
                p("div", {
                  class: "td-line",
                  innerHTML: d.value(h, f, g)
                }, null, 8, lr)
              ], 6))), 128))
            ]))), 128)) : (I(), M("tr", sr, [
              p("td", {
                colspan: u.columns.length,
                class: "no-data"
              }, [
                gn(u.$slots, "no-data", {}, () => [
                  lt(" Không có dữ liệu ")
                ], !0)
              ], 8, ur)
            ]))
          ])
        ])
      ], 6);
    };
  }
}), Gt = (t, e) => {
  const n = t.__vccOpts || t;
  for (const [o, r] of e)
    n[o] = r;
  return n;
}, Jn = /* @__PURE__ */ Gt(dr, [["__scopeId", "data-v-e0be3805"]]);
/*!
  * vue-draggable-next v2.2.0
  * (c) 2023 Anish George
  * @license MIT
  */
/**!
 * Sortable 1.14.0
 * @author	RubaXa   <trash@rubaxa.org>
 * @author	owenm    <owen23355@gmail.com>
 * @license MIT
 */
function Kn(t, e) {
  var n = Object.keys(t);
  if (Object.getOwnPropertySymbols) {
    var o = Object.getOwnPropertySymbols(t);
    e && (o = o.filter(function(r) {
      return Object.getOwnPropertyDescriptor(t, r).enumerable;
    })), n.push.apply(n, o);
  }
  return n;
}
function Oe(t) {
  for (var e = 1; e < arguments.length; e++) {
    var n = arguments[e] != null ? arguments[e] : {};
    e % 2 ? Kn(Object(n), !0).forEach(function(o) {
      fr(t, o, n[o]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(t, Object.getOwnPropertyDescriptors(n)) : Kn(Object(n)).forEach(function(o) {
      Object.defineProperty(t, o, Object.getOwnPropertyDescriptor(n, o));
    });
  }
  return t;
}
function Mt(t) {
  "@babel/helpers - typeof";
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Mt = function(e) {
    return typeof e;
  } : Mt = function(e) {
    return e && typeof Symbol == "function" && e.constructor === Symbol && e !== Symbol.prototype ? "symbol" : typeof e;
  }, Mt(t);
}
function fr(t, e, n) {
  return e in t ? Object.defineProperty(t, e, {
    value: n,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : t[e] = n, t;
}
function $e() {
  return $e = Object.assign || function(t) {
    for (var e = 1; e < arguments.length; e++) {
      var n = arguments[e];
      for (var o in n)
        Object.prototype.hasOwnProperty.call(n, o) && (t[o] = n[o]);
    }
    return t;
  }, $e.apply(this, arguments);
}
function pr(t, e) {
  if (t == null)
    return {};
  var n = {}, o = Object.keys(t), r, i;
  for (i = 0; i < o.length; i++)
    r = o[i], !(e.indexOf(r) >= 0) && (n[r] = t[r]);
  return n;
}
function vr(t, e) {
  if (t == null)
    return {};
  var n = pr(t, e), o, r;
  if (Object.getOwnPropertySymbols) {
    var i = Object.getOwnPropertySymbols(t);
    for (r = 0; r < i.length; r++)
      o = i[r], !(e.indexOf(o) >= 0) && Object.prototype.propertyIsEnumerable.call(t, o) && (n[o] = t[o]);
  }
  return n;
}
var hr = "1.14.0";
function Fe(t) {
  if (typeof window < "u" && window.navigator)
    return !!/* @__PURE__ */ navigator.userAgent.match(t);
}
var Ie = Fe(/(?:Trident.*rv[ :]?11\.|msie|iemobile|Windows Phone)/i), wt = Fe(/Edge/i), Qn = Fe(/firefox/i), st = Fe(/safari/i) && !Fe(/chrome/i) && !Fe(/android/i), wo = Fe(/iP(ad|od|hone)/i), gr = Fe(/chrome/i) && Fe(/android/i), _o = {
  capture: !1,
  passive: !1
};
function N(t, e, n) {
  t.addEventListener(e, n, !Ie && _o);
}
function B(t, e, n) {
  t.removeEventListener(e, n, !Ie && _o);
}
function Ht(t, e) {
  if (e) {
    if (e[0] === ">" && (e = e.substring(1)), t)
      try {
        if (t.matches)
          return t.matches(e);
        if (t.msMatchesSelector)
          return t.msMatchesSelector(e);
        if (t.webkitMatchesSelector)
          return t.webkitMatchesSelector(e);
      } catch {
        return !1;
      }
    return !1;
  }
}
function mr(t) {
  return t.host && t !== document && t.host.nodeType ? t.host : t.parentNode;
}
function Ee(t, e, n, o) {
  if (t) {
    n = n || document;
    do {
      if (e != null && (e[0] === ">" ? t.parentNode === n && Ht(t, e) : Ht(t, e)) || o && t === n)
        return t;
      if (t === n)
        break;
    } while (t = mr(t));
  }
  return null;
}
var Zn = /\s+/g;
function ce(t, e, n) {
  if (t && e)
    if (t.classList)
      t.classList[n ? "add" : "remove"](e);
    else {
      var o = (" " + t.className + " ").replace(Zn, " ").replace(" " + e + " ", " ");
      t.className = (o + (n ? " " + e : "")).replace(Zn, " ");
    }
}
function $(t, e, n) {
  var o = t && t.style;
  if (o) {
    if (n === void 0)
      return document.defaultView && document.defaultView.getComputedStyle ? n = document.defaultView.getComputedStyle(t, "") : t.currentStyle && (n = t.currentStyle), e === void 0 ? n : n[e];
    !(e in o) && e.indexOf("webkit") === -1 && (e = "-webkit-" + e), o[e] = n + (typeof n == "string" ? "" : "px");
  }
}
function Qe(t, e) {
  var n = "";
  if (typeof t == "string")
    n = t;
  else
    do {
      var o = $(t, "transform");
      o && o !== "none" && (n = o + " " + n);
    } while (!e && (t = t.parentNode));
  var r = window.DOMMatrix || window.WebKitCSSMatrix || window.CSSMatrix || window.MSCSSMatrix;
  return r && new r(n);
}
function To(t, e, n) {
  if (t) {
    var o = t.getElementsByTagName(e), r = 0, i = o.length;
    if (n)
      for (; r < i; r++)
        n(o[r], r);
    return o;
  }
  return [];
}
function xe() {
  var t = document.scrollingElement;
  return t || document.documentElement;
}
function G(t, e, n, o, r) {
  if (!(!t.getBoundingClientRect && t !== window)) {
    var i, a, l, s, c, d, u;
    if (t !== window && t.parentNode && t !== xe() ? (i = t.getBoundingClientRect(), a = i.top, l = i.left, s = i.bottom, c = i.right, d = i.height, u = i.width) : (a = 0, l = 0, s = window.innerHeight, c = window.innerWidth, d = window.innerHeight, u = window.innerWidth), (e || n) && t !== window && (r = r || t.parentNode, !Ie))
      do
        if (r && r.getBoundingClientRect && ($(r, "transform") !== "none" || n && $(r, "position") !== "static")) {
          var b = r.getBoundingClientRect();
          a -= b.top + parseInt($(r, "border-top-width")), l -= b.left + parseInt($(r, "border-left-width")), s = a + i.height, c = l + i.width;
          break;
        }
      while (r = r.parentNode);
    if (o && t !== window) {
      var y = Qe(r || t), h = y && y.a, g = y && y.d;
      y && (a /= g, l /= h, u /= h, d /= g, s = a + d, c = l + u);
    }
    return {
      top: a,
      left: l,
      bottom: s,
      right: c,
      width: u,
      height: d
    };
  }
}
function eo(t, e, n) {
  for (var o = Ne(t, !0), r = G(t)[e]; o; ) {
    var i = G(o)[n], a = void 0;
    if (n === "top" || n === "left" ? a = r >= i : a = r <= i, !a)
      return o;
    if (o === xe())
      break;
    o = Ne(o, !1);
  }
  return !1;
}
function Ze(t, e, n, o) {
  for (var r = 0, i = 0, a = t.children; i < a.length; ) {
    if (a[i].style.display !== "none" && a[i] !== L.ghost && (o || a[i] !== L.dragged) && Ee(a[i], n.draggable, t, !1)) {
      if (r === e)
        return a[i];
      r++;
    }
    i++;
  }
  return null;
}
function On(t, e) {
  for (var n = t.lastElementChild; n && (n === L.ghost || $(n, "display") === "none" || e && !Ht(n, e)); )
    n = n.previousElementSibling;
  return n || null;
}
function he(t, e) {
  var n = 0;
  if (!t || !t.parentNode)
    return -1;
  for (; t = t.previousElementSibling; )
    t.nodeName.toUpperCase() !== "TEMPLATE" && t !== L.clone && (!e || Ht(t, e)) && n++;
  return n;
}
function to(t) {
  var e = 0, n = 0, o = xe();
  if (t)
    do {
      var r = Qe(t), i = r.a, a = r.d;
      e += t.scrollLeft * i, n += t.scrollTop * a;
    } while (t !== o && (t = t.parentNode));
  return [e, n];
}
function br(t, e) {
  for (var n in t)
    if (t.hasOwnProperty(n)) {
      for (var o in e)
        if (e.hasOwnProperty(o) && e[o] === t[n][o])
          return Number(n);
    }
  return -1;
}
function Ne(t, e) {
  if (!t || !t.getBoundingClientRect)
    return xe();
  var n = t, o = !1;
  do
    if (n.clientWidth < n.scrollWidth || n.clientHeight < n.scrollHeight) {
      var r = $(n);
      if (n.clientWidth < n.scrollWidth && (r.overflowX == "auto" || r.overflowX == "scroll") || n.clientHeight < n.scrollHeight && (r.overflowY == "auto" || r.overflowY == "scroll")) {
        if (!n.getBoundingClientRect || n === document.body)
          return xe();
        if (o || e)
          return n;
        o = !0;
      }
    }
  while (n = n.parentNode);
  return xe();
}
function yr(t, e) {
  if (t && e)
    for (var n in e)
      e.hasOwnProperty(n) && (t[n] = e[n]);
  return t;
}
function tn(t, e) {
  return Math.round(t.top) === Math.round(e.top) && Math.round(t.left) === Math.round(e.left) && Math.round(t.height) === Math.round(e.height) && Math.round(t.width) === Math.round(e.width);
}
var ut;
function Co(t, e) {
  return function() {
    if (!ut) {
      var n = arguments, o = this;
      n.length === 1 ? t.call(o, n[0]) : t.apply(o, n), ut = setTimeout(function() {
        ut = void 0;
      }, e);
    }
  };
}
function wr() {
  clearTimeout(ut), ut = void 0;
}
function Do(t, e, n) {
  t.scrollLeft += e, t.scrollTop += n;
}
function Eo(t) {
  var e = window.Polymer, n = window.jQuery || window.Zepto;
  return e && e.dom ? e.dom(t).cloneNode(!0) : n ? n(t).clone(!0)[0] : t.cloneNode(!0);
}
var pe = "Sortable" + (/* @__PURE__ */ new Date()).getTime();
function _r() {
  var t = [], e;
  return {
    captureAnimationState: function() {
      if (t = [], !!this.options.animation) {
        var o = [].slice.call(this.el.children);
        o.forEach(function(r) {
          if (!($(r, "display") === "none" || r === L.ghost)) {
            t.push({
              target: r,
              rect: G(r)
            });
            var i = Oe({}, t[t.length - 1].rect);
            if (r.thisAnimationDuration) {
              var a = Qe(r, !0);
              a && (i.top -= a.f, i.left -= a.e);
            }
            r.fromRect = i;
          }
        });
      }
    },
    addAnimationState: function(o) {
      t.push(o);
    },
    removeAnimationState: function(o) {
      t.splice(br(t, {
        target: o
      }), 1);
    },
    animateAll: function(o) {
      var r = this;
      if (!this.options.animation) {
        clearTimeout(e), typeof o == "function" && o();
        return;
      }
      var i = !1, a = 0;
      t.forEach(function(l) {
        var s = 0, c = l.target, d = c.fromRect, u = G(c), b = c.prevFromRect, y = c.prevToRect, h = l.rect, g = Qe(c, !0);
        g && (u.top -= g.f, u.left -= g.e), c.toRect = u, c.thisAnimationDuration && tn(b, u) && !tn(d, u) && // Make sure animatingRect is on line between toRect & fromRect
        (h.top - u.top) / (h.left - u.left) === (d.top - u.top) / (d.left - u.left) && (s = Cr(h, b, y, r.options)), tn(u, d) || (c.prevFromRect = d, c.prevToRect = u, s || (s = r.options.animation), r.animate(c, h, u, s)), s && (i = !0, a = Math.max(a, s), clearTimeout(c.animationResetTimer), c.animationResetTimer = setTimeout(function() {
          c.animationTime = 0, c.prevFromRect = null, c.fromRect = null, c.prevToRect = null, c.thisAnimationDuration = null;
        }, s), c.thisAnimationDuration = s);
      }), clearTimeout(e), i ? e = setTimeout(function() {
        typeof o == "function" && o();
      }, a) : typeof o == "function" && o(), t = [];
    },
    animate: function(o, r, i, a) {
      if (a) {
        $(o, "transition", ""), $(o, "transform", "");
        var l = Qe(this.el), s = l && l.a, c = l && l.d, d = (r.left - i.left) / (s || 1), u = (r.top - i.top) / (c || 1);
        o.animatingX = !!d, o.animatingY = !!u, $(o, "transform", "translate3d(" + d + "px," + u + "px,0)"), this.forRepaintDummy = Tr(o), $(o, "transition", "transform " + a + "ms" + (this.options.easing ? " " + this.options.easing : "")), $(o, "transform", "translate3d(0,0,0)"), typeof o.animated == "number" && clearTimeout(o.animated), o.animated = setTimeout(function() {
          $(o, "transition", ""), $(o, "transform", ""), o.animated = !1, o.animatingX = !1, o.animatingY = !1;
        }, a);
      }
    }
  };
}
function Tr(t) {
  return t.offsetWidth;
}
function Cr(t, e, n, o) {
  return Math.sqrt(Math.pow(e.top - t.top, 2) + Math.pow(e.left - t.left, 2)) / Math.sqrt(Math.pow(e.top - n.top, 2) + Math.pow(e.left - n.left, 2)) * o.animation;
}
var qe = [], nn = {
  initializeByDefault: !0
}, _t = {
  mount: function(e) {
    for (var n in nn)
      nn.hasOwnProperty(n) && !(n in e) && (e[n] = nn[n]);
    qe.forEach(function(o) {
      if (o.pluginName === e.pluginName)
        throw "Sortable: Cannot mount plugin ".concat(e.pluginName, " more than once");
    }), qe.push(e);
  },
  pluginEvent: function(e, n, o) {
    var r = this;
    this.eventCanceled = !1, o.cancel = function() {
      r.eventCanceled = !0;
    };
    var i = e + "Global";
    qe.forEach(function(a) {
      n[a.pluginName] && (n[a.pluginName][i] && n[a.pluginName][i](Oe({
        sortable: n
      }, o)), n.options[a.pluginName] && n[a.pluginName][e] && n[a.pluginName][e](Oe({
        sortable: n
      }, o)));
    });
  },
  initializePlugins: function(e, n, o, r) {
    qe.forEach(function(l) {
      var s = l.pluginName;
      if (!(!e.options[s] && !l.initializeByDefault)) {
        var c = new l(e, n, e.options);
        c.sortable = e, c.options = e.options, e[s] = c, $e(o, c.defaults);
      }
    });
    for (var i in e.options)
      if (e.options.hasOwnProperty(i)) {
        var a = this.modifyOption(e, i, e.options[i]);
        typeof a < "u" && (e.options[i] = a);
      }
  },
  getEventProperties: function(e, n) {
    var o = {};
    return qe.forEach(function(r) {
      typeof r.eventProperties == "function" && $e(o, r.eventProperties.call(n[r.pluginName], e));
    }), o;
  },
  modifyOption: function(e, n, o) {
    var r;
    return qe.forEach(function(i) {
      e[i.pluginName] && i.optionListeners && typeof i.optionListeners[n] == "function" && (r = i.optionListeners[n].call(e[i.pluginName], o));
    }), r;
  }
};
function Dr(t) {
  var e = t.sortable, n = t.rootEl, o = t.name, r = t.targetEl, i = t.cloneEl, a = t.toEl, l = t.fromEl, s = t.oldIndex, c = t.newIndex, d = t.oldDraggableIndex, u = t.newDraggableIndex, b = t.originalEvent, y = t.putSortable, h = t.extraEventProperties;
  if (e = e || n && n[pe], !!e) {
    var g, f = e.options, D = "on" + o.charAt(0).toUpperCase() + o.substr(1);
    window.CustomEvent && !Ie && !wt ? g = new CustomEvent(o, {
      bubbles: !0,
      cancelable: !0
    }) : (g = document.createEvent("Event"), g.initEvent(o, !0, !0)), g.to = a || n, g.from = l || n, g.item = r || n, g.clone = i, g.oldIndex = s, g.newIndex = c, g.oldDraggableIndex = d, g.newDraggableIndex = u, g.originalEvent = b, g.pullMode = y ? y.lastPutMode : void 0;
    var x = Oe(Oe({}, h), _t.getEventProperties(o, e));
    for (var w in x)
      g[w] = x[w];
    n && n.dispatchEvent(g), f[D] && f[D].call(e, g);
  }
}
var Er = ["evt"], se = function(e, n) {
  var o = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, r = o.evt, i = vr(o, Er);
  _t.pluginEvent.bind(L)(e, n, Oe({
    dragEl: _,
    parentEl: Y,
    ghostEl: P,
    rootEl: R,
    nextEl: Ue,
    lastDownEl: Pt,
    cloneEl: j,
    cloneHidden: Be,
    dragStarted: rt,
    putSortable: Z,
    activeSortable: L.active,
    originalEvent: r,
    oldIndex: Ke,
    oldDraggableIndex: ct,
    newIndex: de,
    newDraggableIndex: Pe,
    hideGhostForTarget: Ao,
    unhideGhostForTarget: ko,
    cloneNowHidden: function() {
      Be = !0;
    },
    cloneNowShown: function() {
      Be = !1;
    },
    dispatchSortableEvent: function(l) {
      ae({
        sortable: n,
        name: l,
        originalEvent: r
      });
    }
  }, i));
};
function ae(t) {
  Dr(Oe({
    putSortable: Z,
    cloneEl: j,
    targetEl: _,
    rootEl: R,
    oldIndex: Ke,
    oldDraggableIndex: ct,
    newIndex: de,
    newDraggableIndex: Pe
  }, t));
}
var _, Y, P, R, Ue, Pt, j, Be, Ke, de, ct, Pe, Ot, Z, Je = !1, Wt = !1, Ut = [], He, we, on, rn, no, oo, rt, Ge, dt, ft = !1, At = !1, Bt, oe, an = [], bn = !1, zt = [], Jt = typeof document < "u", kt = wo, ro = wt || Ie ? "cssFloat" : "float", xr = Jt && !gr && !wo && "draggable" in document.createElement("div"), xo = function() {
  if (Jt) {
    if (Ie)
      return !1;
    var t = document.createElement("x");
    return t.style.cssText = "pointer-events:auto", t.style.pointerEvents === "auto";
  }
}(), So = function(e, n) {
  var o = $(e), r = parseInt(o.width) - parseInt(o.paddingLeft) - parseInt(o.paddingRight) - parseInt(o.borderLeftWidth) - parseInt(o.borderRightWidth), i = Ze(e, 0, n), a = Ze(e, 1, n), l = i && $(i), s = a && $(a), c = l && parseInt(l.marginLeft) + parseInt(l.marginRight) + G(i).width, d = s && parseInt(s.marginLeft) + parseInt(s.marginRight) + G(a).width;
  if (o.display === "flex")
    return o.flexDirection === "column" || o.flexDirection === "column-reverse" ? "vertical" : "horizontal";
  if (o.display === "grid")
    return o.gridTemplateColumns.split(" ").length <= 1 ? "vertical" : "horizontal";
  if (i && l.float && l.float !== "none") {
    var u = l.float === "left" ? "left" : "right";
    return a && (s.clear === "both" || s.clear === u) ? "vertical" : "horizontal";
  }
  return i && (l.display === "block" || l.display === "flex" || l.display === "table" || l.display === "grid" || c >= r && o[ro] === "none" || a && o[ro] === "none" && c + d > r) ? "vertical" : "horizontal";
}, Sr = function(e, n, o) {
  var r = o ? e.left : e.top, i = o ? e.right : e.bottom, a = o ? e.width : e.height, l = o ? n.left : n.top, s = o ? n.right : n.bottom, c = o ? n.width : n.height;
  return r === l || i === s || r + a / 2 === l + c / 2;
}, Or = function(e, n) {
  var o;
  return Ut.some(function(r) {
    var i = r[pe].options.emptyInsertThreshold;
    if (!(!i || On(r))) {
      var a = G(r), l = e >= a.left - i && e <= a.right + i, s = n >= a.top - i && n <= a.bottom + i;
      if (l && s)
        return o = r;
    }
  }), o;
}, Oo = function(e) {
  function n(i, a) {
    return function(l, s, c, d) {
      var u = l.options.group.name && s.options.group.name && l.options.group.name === s.options.group.name;
      if (i == null && (a || u))
        return !0;
      if (i == null || i === !1)
        return !1;
      if (a && i === "clone")
        return i;
      if (typeof i == "function")
        return n(i(l, s, c, d), a)(l, s, c, d);
      var b = (a ? l : s).options.group.name;
      return i === !0 || typeof i == "string" && i === b || i.join && i.indexOf(b) > -1;
    };
  }
  var o = {}, r = e.group;
  (!r || Mt(r) != "object") && (r = {
    name: r
  }), o.name = r.name, o.checkPull = n(r.pull, !0), o.checkPut = n(r.put), o.revertClone = r.revertClone, e.group = o;
}, Ao = function() {
  !xo && P && $(P, "display", "none");
}, ko = function() {
  !xo && P && $(P, "display", "");
};
Jt && document.addEventListener("click", function(t) {
  if (Wt)
    return t.preventDefault(), t.stopPropagation && t.stopPropagation(), t.stopImmediatePropagation && t.stopImmediatePropagation(), Wt = !1, !1;
}, !0);
var We = function(e) {
  if (_) {
    e = e.touches ? e.touches[0] : e;
    var n = Or(e.clientX, e.clientY);
    if (n) {
      var o = {};
      for (var r in e)
        e.hasOwnProperty(r) && (o[r] = e[r]);
      o.target = o.rootEl = n, o.preventDefault = void 0, o.stopPropagation = void 0, n[pe]._onDragOver(o);
    }
  }
}, Ar = function(e) {
  _ && _.parentNode[pe]._isOutsideThisEl(e.target);
};
function L(t, e) {
  if (!(t && t.nodeType && t.nodeType === 1))
    throw "Sortable: `el` must be an HTMLElement, not ".concat({}.toString.call(t));
  this.el = t, this.options = e = $e({}, e), t[pe] = this;
  var n = {
    group: null,
    sort: !0,
    disabled: !1,
    store: null,
    handle: null,
    draggable: /^[uo]l$/i.test(t.nodeName) ? ">li" : ">*",
    swapThreshold: 1,
    // percentage; 0 <= x <= 1
    invertSwap: !1,
    // invert always
    invertedSwapThreshold: null,
    // will be set to same as swapThreshold if default
    removeCloneOnHide: !0,
    direction: function() {
      return So(t, this.options);
    },
    ghostClass: "sortable-ghost",
    chosenClass: "sortable-chosen",
    dragClass: "sortable-drag",
    ignore: "a, img",
    filter: null,
    preventOnFilter: !0,
    animation: 0,
    easing: null,
    setData: function(a, l) {
      a.setData("Text", l.textContent);
    },
    dropBubble: !1,
    dragoverBubble: !1,
    dataIdAttr: "data-id",
    delay: 0,
    delayOnTouchOnly: !1,
    touchStartThreshold: (Number.parseInt ? Number : window).parseInt(window.devicePixelRatio, 10) || 1,
    forceFallback: !1,
    fallbackClass: "sortable-fallback",
    fallbackOnBody: !1,
    fallbackTolerance: 0,
    fallbackOffset: {
      x: 0,
      y: 0
    },
    supportPointer: L.supportPointer !== !1 && "PointerEvent" in window && !st,
    emptyInsertThreshold: 5
  };
  _t.initializePlugins(this, t, n);
  for (var o in n)
    !(o in e) && (e[o] = n[o]);
  Oo(e);
  for (var r in this)
    r.charAt(0) === "_" && typeof this[r] == "function" && (this[r] = this[r].bind(this));
  this.nativeDraggable = e.forceFallback ? !1 : xr, this.nativeDraggable && (this.options.touchStartThreshold = 1), e.supportPointer ? N(t, "pointerdown", this._onTapStart) : (N(t, "mousedown", this._onTapStart), N(t, "touchstart", this._onTapStart)), this.nativeDraggable && (N(t, "dragover", this), N(t, "dragenter", this)), Ut.push(this.el), e.store && e.store.get && this.sort(e.store.get(this) || []), $e(this, _r());
}
L.prototype = /** @lends Sortable.prototype */
{
  constructor: L,
  _isOutsideThisEl: function(e) {
    !this.el.contains(e) && e !== this.el && (Ge = null);
  },
  _getDirection: function(e, n) {
    return typeof this.options.direction == "function" ? this.options.direction.call(this, e, n, _) : this.options.direction;
  },
  _onTapStart: function(e) {
    if (e.cancelable) {
      var n = this, o = this.el, r = this.options, i = r.preventOnFilter, a = e.type, l = e.touches && e.touches[0] || e.pointerType && e.pointerType === "touch" && e, s = (l || e).target, c = e.target.shadowRoot && (e.path && e.path[0] || e.composedPath && e.composedPath()[0]) || s, d = r.filter;
      if (Br(o), !_ && !(/mousedown|pointerdown/.test(a) && e.button !== 0 || r.disabled) && !c.isContentEditable && !(!this.nativeDraggable && st && s && s.tagName.toUpperCase() === "SELECT") && (s = Ee(s, r.draggable, o, !1), !(s && s.animated) && Pt !== s)) {
        if (Ke = he(s), ct = he(s, r.draggable), typeof d == "function") {
          if (d.call(this, e, s, this)) {
            ae({
              sortable: n,
              rootEl: c,
              name: "filter",
              targetEl: s,
              toEl: o,
              fromEl: o
            }), se("filter", n, {
              evt: e
            }), i && e.cancelable && e.preventDefault();
            return;
          }
        } else if (d && (d = d.split(",").some(function(u) {
          if (u = Ee(c, u.trim(), o, !1), u)
            return ae({
              sortable: n,
              rootEl: u,
              name: "filter",
              targetEl: s,
              fromEl: o,
              toEl: o
            }), se("filter", n, {
              evt: e
            }), !0;
        }), d)) {
          i && e.cancelable && e.preventDefault();
          return;
        }
        r.handle && !Ee(c, r.handle, o, !1) || this._prepareDragStart(e, l, s);
      }
    }
  },
  _prepareDragStart: function(e, n, o) {
    var r = this, i = r.el, a = r.options, l = i.ownerDocument, s;
    if (o && !_ && o.parentNode === i) {
      var c = G(o);
      if (R = i, _ = o, Y = _.parentNode, Ue = _.nextSibling, Pt = o, Ot = a.group, L.dragged = _, He = {
        target: _,
        clientX: (n || e).clientX,
        clientY: (n || e).clientY
      }, no = He.clientX - c.left, oo = He.clientY - c.top, this._lastX = (n || e).clientX, this._lastY = (n || e).clientY, _.style["will-change"] = "all", s = function() {
        if (se("delayEnded", r, {
          evt: e
        }), L.eventCanceled) {
          r._onDrop();
          return;
        }
        r._disableDelayedDragEvents(), !Qn && r.nativeDraggable && (_.draggable = !0), r._triggerDragStart(e, n), ae({
          sortable: r,
          name: "choose",
          originalEvent: e
        }), ce(_, a.chosenClass, !0);
      }, a.ignore.split(",").forEach(function(d) {
        To(_, d.trim(), ln);
      }), N(l, "dragover", We), N(l, "mousemove", We), N(l, "touchmove", We), N(l, "mouseup", r._onDrop), N(l, "touchend", r._onDrop), N(l, "touchcancel", r._onDrop), Qn && this.nativeDraggable && (this.options.touchStartThreshold = 4, _.draggable = !0), se("delayStart", this, {
        evt: e
      }), a.delay && (!a.delayOnTouchOnly || n) && (!this.nativeDraggable || !(wt || Ie))) {
        if (L.eventCanceled) {
          this._onDrop();
          return;
        }
        N(l, "mouseup", r._disableDelayedDrag), N(l, "touchend", r._disableDelayedDrag), N(l, "touchcancel", r._disableDelayedDrag), N(l, "mousemove", r._delayedDragTouchMoveHandler), N(l, "touchmove", r._delayedDragTouchMoveHandler), a.supportPointer && N(l, "pointermove", r._delayedDragTouchMoveHandler), r._dragStartTimer = setTimeout(s, a.delay);
      } else
        s();
    }
  },
  _delayedDragTouchMoveHandler: function(e) {
    var n = e.touches ? e.touches[0] : e;
    Math.max(Math.abs(n.clientX - this._lastX), Math.abs(n.clientY - this._lastY)) >= Math.floor(this.options.touchStartThreshold / (this.nativeDraggable && window.devicePixelRatio || 1)) && this._disableDelayedDrag();
  },
  _disableDelayedDrag: function() {
    _ && ln(_), clearTimeout(this._dragStartTimer), this._disableDelayedDragEvents();
  },
  _disableDelayedDragEvents: function() {
    var e = this.el.ownerDocument;
    B(e, "mouseup", this._disableDelayedDrag), B(e, "touchend", this._disableDelayedDrag), B(e, "touchcancel", this._disableDelayedDrag), B(e, "mousemove", this._delayedDragTouchMoveHandler), B(e, "touchmove", this._delayedDragTouchMoveHandler), B(e, "pointermove", this._delayedDragTouchMoveHandler);
  },
  _triggerDragStart: function(e, n) {
    n = n || e.pointerType == "touch" && e, !this.nativeDraggable || n ? this.options.supportPointer ? N(document, "pointermove", this._onTouchMove) : n ? N(document, "touchmove", this._onTouchMove) : N(document, "mousemove", this._onTouchMove) : (N(_, "dragend", this), N(R, "dragstart", this._onDragStart));
    try {
      document.selection ? Nt(function() {
        document.selection.empty();
      }) : window.getSelection().removeAllRanges();
    } catch {
    }
  },
  _dragStarted: function(e, n) {
    if (Je = !1, R && _) {
      se("dragStarted", this, {
        evt: n
      }), this.nativeDraggable && N(document, "dragover", Ar);
      var o = this.options;
      !e && ce(_, o.dragClass, !1), ce(_, o.ghostClass, !0), L.active = this, e && this._appendGhost(), ae({
        sortable: this,
        name: "start",
        originalEvent: n
      });
    } else
      this._nulling();
  },
  _emulateDragOver: function() {
    if (we) {
      this._lastX = we.clientX, this._lastY = we.clientY, Ao();
      for (var e = document.elementFromPoint(we.clientX, we.clientY), n = e; e && e.shadowRoot && (e = e.shadowRoot.elementFromPoint(we.clientX, we.clientY), e !== n); )
        n = e;
      if (_.parentNode[pe]._isOutsideThisEl(e), n)
        do {
          if (n[pe]) {
            var o = void 0;
            if (o = n[pe]._onDragOver({
              clientX: we.clientX,
              clientY: we.clientY,
              target: e,
              rootEl: n
            }), o && !this.options.dragoverBubble)
              break;
          }
          e = n;
        } while (n = n.parentNode);
      ko();
    }
  },
  _onTouchMove: function(e) {
    if (He) {
      var n = this.options, o = n.fallbackTolerance, r = n.fallbackOffset, i = e.touches ? e.touches[0] : e, a = P && Qe(P, !0), l = P && a && a.a, s = P && a && a.d, c = kt && oe && to(oe), d = (i.clientX - He.clientX + r.x) / (l || 1) + (c ? c[0] - an[0] : 0) / (l || 1), u = (i.clientY - He.clientY + r.y) / (s || 1) + (c ? c[1] - an[1] : 0) / (s || 1);
      if (!L.active && !Je) {
        if (o && Math.max(Math.abs(i.clientX - this._lastX), Math.abs(i.clientY - this._lastY)) < o)
          return;
        this._onDragStart(e, !0);
      }
      if (P) {
        a ? (a.e += d - (on || 0), a.f += u - (rn || 0)) : a = {
          a: 1,
          b: 0,
          c: 0,
          d: 1,
          e: d,
          f: u
        };
        var b = "matrix(".concat(a.a, ",").concat(a.b, ",").concat(a.c, ",").concat(a.d, ",").concat(a.e, ",").concat(a.f, ")");
        $(P, "webkitTransform", b), $(P, "mozTransform", b), $(P, "msTransform", b), $(P, "transform", b), on = d, rn = u, we = i;
      }
      e.cancelable && e.preventDefault();
    }
  },
  _appendGhost: function() {
    if (!P) {
      var e = this.options.fallbackOnBody ? document.body : R, n = G(_, !0, kt, !0, e), o = this.options;
      if (kt) {
        for (oe = e; $(oe, "position") === "static" && $(oe, "transform") === "none" && oe !== document; )
          oe = oe.parentNode;
        oe !== document.body && oe !== document.documentElement ? (oe === document && (oe = xe()), n.top += oe.scrollTop, n.left += oe.scrollLeft) : oe = xe(), an = to(oe);
      }
      P = _.cloneNode(!0), ce(P, o.ghostClass, !1), ce(P, o.fallbackClass, !0), ce(P, o.dragClass, !0), $(P, "transition", ""), $(P, "transform", ""), $(P, "box-sizing", "border-box"), $(P, "margin", 0), $(P, "top", n.top), $(P, "left", n.left), $(P, "width", n.width), $(P, "height", n.height), $(P, "opacity", "0.8"), $(P, "position", kt ? "absolute" : "fixed"), $(P, "zIndex", "100000"), $(P, "pointerEvents", "none"), L.ghost = P, e.appendChild(P), $(P, "transform-origin", no / parseInt(P.style.width) * 100 + "% " + oo / parseInt(P.style.height) * 100 + "%");
    }
  },
  _onDragStart: function(e, n) {
    var o = this, r = e.dataTransfer, i = o.options;
    if (se("dragStart", this, {
      evt: e
    }), L.eventCanceled) {
      this._onDrop();
      return;
    }
    se("setupClone", this), L.eventCanceled || (j = Eo(_), j.draggable = !1, j.style["will-change"] = "", this._hideClone(), ce(j, this.options.chosenClass, !1), L.clone = j), o.cloneId = Nt(function() {
      se("clone", o), !L.eventCanceled && (o.options.removeCloneOnHide || R.insertBefore(j, _), o._hideClone(), ae({
        sortable: o,
        name: "clone"
      }));
    }), !n && ce(_, i.dragClass, !0), n ? (Wt = !0, o._loopId = setInterval(o._emulateDragOver, 50)) : (B(document, "mouseup", o._onDrop), B(document, "touchend", o._onDrop), B(document, "touchcancel", o._onDrop), r && (r.effectAllowed = "move", i.setData && i.setData.call(o, r, _)), N(document, "drop", o), $(_, "transform", "translateZ(0)")), Je = !0, o._dragStartId = Nt(o._dragStarted.bind(o, n, e)), N(document, "selectstart", o), rt = !0, st && $(document.body, "user-select", "none");
  },
  // Returns true - if no further action is needed (either inserted or another condition)
  _onDragOver: function(e) {
    var n = this.el, o = e.target, r, i, a, l = this.options, s = l.group, c = L.active, d = Ot === s, u = l.sort, b = Z || c, y, h = this, g = !1;
    if (bn)
      return;
    function f(U, J) {
      se(U, h, Oe({
        evt: e,
        isOwner: d,
        axis: y ? "vertical" : "horizontal",
        revert: a,
        dragRect: r,
        targetRect: i,
        canSort: u,
        fromSortable: b,
        target: o,
        completed: x,
        onMove: function(ve, Me) {
          return Ft(R, n, _, r, ve, G(ve), e, Me);
        },
        changed: w
      }, J));
    }
    function D() {
      f("dragOverAnimationCapture"), h.captureAnimationState(), h !== b && b.captureAnimationState();
    }
    function x(U) {
      return f("dragOverCompleted", {
        insertion: U
      }), U && (d ? c._hideClone() : c._showClone(h), h !== b && (ce(_, Z ? Z.options.ghostClass : c.options.ghostClass, !1), ce(_, l.ghostClass, !0)), Z !== h && h !== L.active ? Z = h : h === L.active && Z && (Z = null), b === h && (h._ignoreWhileAnimating = o), h.animateAll(function() {
        f("dragOverAnimationComplete"), h._ignoreWhileAnimating = null;
      }), h !== b && (b.animateAll(), b._ignoreWhileAnimating = null)), (o === _ && !_.animated || o === n && !o.animated) && (Ge = null), !l.dragoverBubble && !e.rootEl && o !== document && (_.parentNode[pe]._isOutsideThisEl(e.target), !U && We(e)), !l.dragoverBubble && e.stopPropagation && e.stopPropagation(), g = !0;
    }
    function w() {
      de = he(_), Pe = he(_, l.draggable), ae({
        sortable: h,
        name: "change",
        toEl: n,
        newIndex: de,
        newDraggableIndex: Pe,
        originalEvent: e
      });
    }
    if (e.preventDefault !== void 0 && e.cancelable && e.preventDefault(), o = Ee(o, l.draggable, n, !0), f("dragOver"), L.eventCanceled)
      return g;
    if (_.contains(e.target) || o.animated && o.animatingX && o.animatingY || h._ignoreWhileAnimating === o)
      return x(!1);
    if (Wt = !1, c && !l.disabled && (d ? u || (a = Y !== R) : Z === this || (this.lastPutMode = Ot.checkPull(this, c, _, e)) && s.checkPut(this, c, _, e))) {
      if (y = this._getDirection(e, o) === "vertical", r = G(_), f("dragOverValid"), L.eventCanceled)
        return g;
      if (a)
        return Y = R, D(), this._hideClone(), f("revert"), L.eventCanceled || (Ue ? R.insertBefore(_, Ue) : R.appendChild(_)), x(!0);
      var T = On(n, l.draggable);
      if (!T || Lr(e, y, this) && !T.animated) {
        if (T === _)
          return x(!1);
        if (T && n === e.target && (o = T), o && (i = G(o)), Ft(R, n, _, r, o, i, e, !!o) !== !1)
          return D(), n.appendChild(_), Y = n, w(), x(!0);
      } else if (T && $r(e, y, this)) {
        var S = Ze(n, 0, l, !0);
        if (S === _)
          return x(!1);
        if (o = S, i = G(o), Ft(R, n, _, r, o, i, e, !1) !== !1)
          return D(), n.insertBefore(_, S), Y = n, w(), x(!0);
      } else if (o.parentNode === n) {
        i = G(o);
        var F = 0, m, C = _.parentNode !== n, v = !Sr(_.animated && _.toRect || r, o.animated && o.toRect || i, y), E = y ? "top" : "left", O = eo(o, "top", "top") || eo(_, "top", "top"), V = O ? O.scrollTop : void 0;
        Ge !== o && (m = i[E], ft = !1, At = !v && l.invertSwap || C), F = Ir(e, o, i, y, v ? 1 : l.swapThreshold, l.invertedSwapThreshold == null ? l.swapThreshold : l.invertedSwapThreshold, At, Ge === o);
        var k;
        if (F !== 0) {
          var H = he(_);
          do
            H -= F, k = Y.children[H];
          while (k && ($(k, "display") === "none" || k === P));
        }
        if (F === 0 || k === o)
          return x(!1);
        Ge = o, dt = F;
        var ie = o.nextElementSibling, W = !1;
        W = F === 1;
        var le = Ft(R, n, _, r, o, i, e, W);
        if (le !== !1)
          return (le === 1 || le === -1) && (W = le === 1), bn = !0, setTimeout(Fr, 30), D(), W && !ie ? n.appendChild(_) : o.parentNode.insertBefore(_, W ? ie : o), O && Do(O, 0, V - O.scrollTop), Y = _.parentNode, m !== void 0 && !At && (Bt = Math.abs(m - G(o)[E])), w(), x(!0);
      }
      if (n.contains(_))
        return x(!1);
    }
    return !1;
  },
  _ignoreWhileAnimating: null,
  _offMoveEvents: function() {
    B(document, "mousemove", this._onTouchMove), B(document, "touchmove", this._onTouchMove), B(document, "pointermove", this._onTouchMove), B(document, "dragover", We), B(document, "mousemove", We), B(document, "touchmove", We);
  },
  _offUpEvents: function() {
    var e = this.el.ownerDocument;
    B(e, "mouseup", this._onDrop), B(e, "touchend", this._onDrop), B(e, "pointerup", this._onDrop), B(e, "touchcancel", this._onDrop), B(document, "selectstart", this);
  },
  _onDrop: function(e) {
    var n = this.el, o = this.options;
    if (de = he(_), Pe = he(_, o.draggable), se("drop", this, {
      evt: e
    }), Y = _ && _.parentNode, de = he(_), Pe = he(_, o.draggable), L.eventCanceled) {
      this._nulling();
      return;
    }
    Je = !1, At = !1, ft = !1, clearInterval(this._loopId), clearTimeout(this._dragStartTimer), yn(this.cloneId), yn(this._dragStartId), this.nativeDraggable && (B(document, "drop", this), B(n, "dragstart", this._onDragStart)), this._offMoveEvents(), this._offUpEvents(), st && $(document.body, "user-select", ""), $(_, "transform", ""), e && (rt && (e.cancelable && e.preventDefault(), !o.dropBubble && e.stopPropagation()), P && P.parentNode && P.parentNode.removeChild(P), (R === Y || Z && Z.lastPutMode !== "clone") && j && j.parentNode && j.parentNode.removeChild(j), _ && (this.nativeDraggable && B(_, "dragend", this), ln(_), _.style["will-change"] = "", rt && !Je && ce(_, Z ? Z.options.ghostClass : this.options.ghostClass, !1), ce(_, this.options.chosenClass, !1), ae({
      sortable: this,
      name: "unchoose",
      toEl: Y,
      newIndex: null,
      newDraggableIndex: null,
      originalEvent: e
    }), R !== Y ? (de >= 0 && (ae({
      rootEl: Y,
      name: "add",
      toEl: Y,
      fromEl: R,
      originalEvent: e
    }), ae({
      sortable: this,
      name: "remove",
      toEl: Y,
      originalEvent: e
    }), ae({
      rootEl: Y,
      name: "sort",
      toEl: Y,
      fromEl: R,
      originalEvent: e
    }), ae({
      sortable: this,
      name: "sort",
      toEl: Y,
      originalEvent: e
    })), Z && Z.save()) : de !== Ke && de >= 0 && (ae({
      sortable: this,
      name: "update",
      toEl: Y,
      originalEvent: e
    }), ae({
      sortable: this,
      name: "sort",
      toEl: Y,
      originalEvent: e
    })), L.active && ((de == null || de === -1) && (de = Ke, Pe = ct), ae({
      sortable: this,
      name: "end",
      toEl: Y,
      originalEvent: e
    }), this.save()))), this._nulling();
  },
  _nulling: function() {
    se("nulling", this), R = _ = Y = P = Ue = j = Pt = Be = He = we = rt = de = Pe = Ke = ct = Ge = dt = Z = Ot = L.dragged = L.ghost = L.clone = L.active = null, zt.forEach(function(e) {
      e.checked = !0;
    }), zt.length = on = rn = 0;
  },
  handleEvent: function(e) {
    switch (e.type) {
      case "drop":
      case "dragend":
        this._onDrop(e);
        break;
      case "dragenter":
      case "dragover":
        _ && (this._onDragOver(e), kr(e));
        break;
      case "selectstart":
        e.preventDefault();
        break;
    }
  },
  /**
   * Serializes the item into an array of string.
   * @returns {String[]}
   */
  toArray: function() {
    for (var e = [], n, o = this.el.children, r = 0, i = o.length, a = this.options; r < i; r++)
      n = o[r], Ee(n, a.draggable, this.el, !1) && e.push(n.getAttribute(a.dataIdAttr) || Pr(n));
    return e;
  },
  /**
   * Sorts the elements according to the array.
   * @param  {String[]}  order  order of the items
   */
  sort: function(e, n) {
    var o = {}, r = this.el;
    this.toArray().forEach(function(i, a) {
      var l = r.children[a];
      Ee(l, this.options.draggable, r, !1) && (o[i] = l);
    }, this), n && this.captureAnimationState(), e.forEach(function(i) {
      o[i] && (r.removeChild(o[i]), r.appendChild(o[i]));
    }), n && this.animateAll();
  },
  /**
   * Save the current sorting
   */
  save: function() {
    var e = this.options.store;
    e && e.set && e.set(this);
  },
  /**
   * For each element in the set, get the first element that matches the selector by testing the element itself and traversing up through its ancestors in the DOM tree.
   * @param   {HTMLElement}  el
   * @param   {String}       [selector]  default: `options.draggable`
   * @returns {HTMLElement|null}
   */
  closest: function(e, n) {
    return Ee(e, n || this.options.draggable, this.el, !1);
  },
  /**
   * Set/get option
   * @param   {string} name
   * @param   {*}      [value]
   * @returns {*}
   */
  option: function(e, n) {
    var o = this.options;
    if (n === void 0)
      return o[e];
    var r = _t.modifyOption(this, e, n);
    typeof r < "u" ? o[e] = r : o[e] = n, e === "group" && Oo(o);
  },
  /**
   * Destroy
   */
  destroy: function() {
    se("destroy", this);
    var e = this.el;
    e[pe] = null, B(e, "mousedown", this._onTapStart), B(e, "touchstart", this._onTapStart), B(e, "pointerdown", this._onTapStart), this.nativeDraggable && (B(e, "dragover", this), B(e, "dragenter", this)), Array.prototype.forEach.call(e.querySelectorAll("[draggable]"), function(n) {
      n.removeAttribute("draggable");
    }), this._onDrop(), this._disableDelayedDragEvents(), Ut.splice(Ut.indexOf(this.el), 1), this.el = e = null;
  },
  _hideClone: function() {
    if (!Be) {
      if (se("hideClone", this), L.eventCanceled)
        return;
      $(j, "display", "none"), this.options.removeCloneOnHide && j.parentNode && j.parentNode.removeChild(j), Be = !0;
    }
  },
  _showClone: function(e) {
    if (e.lastPutMode !== "clone") {
      this._hideClone();
      return;
    }
    if (Be) {
      if (se("showClone", this), L.eventCanceled)
        return;
      _.parentNode == R && !this.options.group.revertClone ? R.insertBefore(j, _) : Ue ? R.insertBefore(j, Ue) : R.appendChild(j), this.options.group.revertClone && this.animate(_, j), $(j, "display", ""), Be = !1;
    }
  }
};
function kr(t) {
  t.dataTransfer && (t.dataTransfer.dropEffect = "move"), t.cancelable && t.preventDefault();
}
function Ft(t, e, n, o, r, i, a, l) {
  var s, c = t[pe], d = c.options.onMove, u;
  return window.CustomEvent && !Ie && !wt ? s = new CustomEvent("move", {
    bubbles: !0,
    cancelable: !0
  }) : (s = document.createEvent("Event"), s.initEvent("move", !0, !0)), s.to = e, s.from = t, s.dragged = n, s.draggedRect = o, s.related = r || e, s.relatedRect = i || G(e), s.willInsertAfter = l, s.originalEvent = a, t.dispatchEvent(s), d && (u = d.call(c, s, a)), u;
}
function ln(t) {
  t.draggable = !1;
}
function Fr() {
  bn = !1;
}
function $r(t, e, n) {
  var o = G(Ze(n.el, 0, n.options, !0)), r = 10;
  return e ? t.clientX < o.left - r || t.clientY < o.top && t.clientX < o.right : t.clientY < o.top - r || t.clientY < o.bottom && t.clientX < o.left;
}
function Lr(t, e, n) {
  var o = G(On(n.el, n.options.draggable)), r = 10;
  return e ? t.clientX > o.right + r || t.clientX <= o.right && t.clientY > o.bottom && t.clientX >= o.left : t.clientX > o.right && t.clientY > o.top || t.clientX <= o.right && t.clientY > o.bottom + r;
}
function Ir(t, e, n, o, r, i, a, l) {
  var s = o ? t.clientY : t.clientX, c = o ? n.height : n.width, d = o ? n.top : n.left, u = o ? n.bottom : n.right, b = !1;
  if (!a) {
    if (l && Bt < c * r) {
      if (!ft && (dt === 1 ? s > d + c * i / 2 : s < u - c * i / 2) && (ft = !0), ft)
        b = !0;
      else if (dt === 1 ? s < d + Bt : s > u - Bt)
        return -dt;
    } else if (s > d + c * (1 - r) / 2 && s < u - c * (1 - r) / 2)
      return Mr(e);
  }
  return b = b || a, b && (s < d + c * i / 2 || s > u - c * i / 2) ? s > d + c / 2 ? 1 : -1 : 0;
}
function Mr(t) {
  return he(_) < he(t) ? 1 : -1;
}
function Pr(t) {
  for (var e = t.tagName + t.className + t.src + t.href + t.textContent, n = e.length, o = 0; n--; )
    o += e.charCodeAt(n);
  return o.toString(36);
}
function Br(t) {
  zt.length = 0;
  for (var e = t.getElementsByTagName("input"), n = e.length; n--; ) {
    var o = e[n];
    o.checked && zt.push(o);
  }
}
function Nt(t) {
  return setTimeout(t, 0);
}
function yn(t) {
  return clearTimeout(t);
}
Jt && N(document, "touchmove", function(t) {
  (L.active || Je) && t.cancelable && t.preventDefault();
});
L.utils = {
  on: N,
  off: B,
  css: $,
  find: To,
  is: function(e, n) {
    return !!Ee(e, n, e, !1);
  },
  extend: yr,
  throttle: Co,
  closest: Ee,
  toggleClass: ce,
  clone: Eo,
  index: he,
  nextTick: Nt,
  cancelNextTick: yn,
  detectDirection: So,
  getChild: Ze
};
L.get = function(t) {
  return t[pe];
};
L.mount = function() {
  for (var t = arguments.length, e = new Array(t), n = 0; n < t; n++)
    e[n] = arguments[n];
  e[0].constructor === Array && (e = e[0]), e.forEach(function(o) {
    if (!o.prototype || !o.prototype.constructor)
      throw "Sortable: Mounted plugin must be a constructor function, not ".concat({}.toString.call(o));
    o.utils && (L.utils = Oe(Oe({}, L.utils), o.utils)), _t.mount(o);
  });
};
L.create = function(t, e) {
  return new L(t, e);
};
L.version = hr;
var X = [], it, wn, _n = !1, sn, un, Xt, at;
function Nr() {
  function t() {
    this.defaults = {
      scroll: !0,
      forceAutoScrollFallback: !1,
      scrollSensitivity: 30,
      scrollSpeed: 10,
      bubbleScroll: !0
    };
    for (var e in this)
      e.charAt(0) === "_" && typeof this[e] == "function" && (this[e] = this[e].bind(this));
  }
  return t.prototype = {
    dragStarted: function(n) {
      var o = n.originalEvent;
      this.sortable.nativeDraggable ? N(document, "dragover", this._handleAutoScroll) : this.options.supportPointer ? N(document, "pointermove", this._handleFallbackAutoScroll) : o.touches ? N(document, "touchmove", this._handleFallbackAutoScroll) : N(document, "mousemove", this._handleFallbackAutoScroll);
    },
    dragOverCompleted: function(n) {
      var o = n.originalEvent;
      !this.options.dragOverBubble && !o.rootEl && this._handleAutoScroll(o);
    },
    drop: function() {
      this.sortable.nativeDraggable ? B(document, "dragover", this._handleAutoScroll) : (B(document, "pointermove", this._handleFallbackAutoScroll), B(document, "touchmove", this._handleFallbackAutoScroll), B(document, "mousemove", this._handleFallbackAutoScroll)), io(), Rt(), wr();
    },
    nulling: function() {
      Xt = wn = it = _n = at = sn = un = null, X.length = 0;
    },
    _handleFallbackAutoScroll: function(n) {
      this._handleAutoScroll(n, !0);
    },
    _handleAutoScroll: function(n, o) {
      var r = this, i = (n.touches ? n.touches[0] : n).clientX, a = (n.touches ? n.touches[0] : n).clientY, l = document.elementFromPoint(i, a);
      if (Xt = n, o || this.options.forceAutoScrollFallback || wt || Ie || st) {
        cn(n, this.options, l, o);
        var s = Ne(l, !0);
        _n && (!at || i !== sn || a !== un) && (at && io(), at = setInterval(function() {
          var c = Ne(document.elementFromPoint(i, a), !0);
          c !== s && (s = c, Rt()), cn(n, r.options, c, o);
        }, 10), sn = i, un = a);
      } else {
        if (!this.options.bubbleScroll || Ne(l, !0) === xe()) {
          Rt();
          return;
        }
        cn(n, this.options, Ne(l, !1), !1);
      }
    }
  }, $e(t, {
    pluginName: "scroll",
    initializeByDefault: !0
  });
}
function Rt() {
  X.forEach(function(t) {
    clearInterval(t.pid);
  }), X = [];
}
function io() {
  clearInterval(at);
}
var cn = Co(function(t, e, n, o) {
  if (e.scroll) {
    var r = (t.touches ? t.touches[0] : t).clientX, i = (t.touches ? t.touches[0] : t).clientY, a = e.scrollSensitivity, l = e.scrollSpeed, s = xe(), c = !1, d;
    wn !== n && (wn = n, Rt(), it = e.scroll, d = e.scrollFn, it === !0 && (it = Ne(n, !0)));
    var u = 0, b = it;
    do {
      var y = b, h = G(y), g = h.top, f = h.bottom, D = h.left, x = h.right, w = h.width, T = h.height, S = void 0, F = void 0, m = y.scrollWidth, C = y.scrollHeight, v = $(y), E = y.scrollLeft, O = y.scrollTop;
      y === s ? (S = w < m && (v.overflowX === "auto" || v.overflowX === "scroll" || v.overflowX === "visible"), F = T < C && (v.overflowY === "auto" || v.overflowY === "scroll" || v.overflowY === "visible")) : (S = w < m && (v.overflowX === "auto" || v.overflowX === "scroll"), F = T < C && (v.overflowY === "auto" || v.overflowY === "scroll"));
      var V = S && (Math.abs(x - r) <= a && E + w < m) - (Math.abs(D - r) <= a && !!E), k = F && (Math.abs(f - i) <= a && O + T < C) - (Math.abs(g - i) <= a && !!O);
      if (!X[u])
        for (var H = 0; H <= u; H++)
          X[H] || (X[H] = {});
      (X[u].vx != V || X[u].vy != k || X[u].el !== y) && (X[u].el = y, X[u].vx = V, X[u].vy = k, clearInterval(X[u].pid), (V != 0 || k != 0) && (c = !0, X[u].pid = setInterval((function() {
        o && this.layer === 0 && L.active._onTouchMove(Xt);
        var ie = X[this.layer].vy ? X[this.layer].vy * l : 0, W = X[this.layer].vx ? X[this.layer].vx * l : 0;
        typeof d == "function" && d.call(L.dragged.parentNode[pe], W, ie, t, Xt, X[this.layer].el) !== "continue" || Do(X[this.layer].el, W, ie);
      }).bind({
        layer: u
      }), 24))), u++;
    } while (e.bubbleScroll && b !== s && (b = Ne(b, !1)));
    _n = c;
  }
}, 30), Fo = function(e) {
  var n = e.originalEvent, o = e.putSortable, r = e.dragEl, i = e.activeSortable, a = e.dispatchSortableEvent, l = e.hideGhostForTarget, s = e.unhideGhostForTarget;
  if (n) {
    var c = o || i;
    l();
    var d = n.changedTouches && n.changedTouches.length ? n.changedTouches[0] : n, u = document.elementFromPoint(d.clientX, d.clientY);
    s(), c && !c.el.contains(u) && (a("spill"), this.onSpill({
      dragEl: r,
      putSortable: o
    }));
  }
};
function An() {
}
An.prototype = {
  startIndex: null,
  dragStart: function(e) {
    var n = e.oldDraggableIndex;
    this.startIndex = n;
  },
  onSpill: function(e) {
    var n = e.dragEl, o = e.putSortable;
    this.sortable.captureAnimationState(), o && o.captureAnimationState();
    var r = Ze(this.sortable.el, this.startIndex, this.options);
    r ? this.sortable.el.insertBefore(n, r) : this.sortable.el.appendChild(n), this.sortable.animateAll(), o && o.animateAll();
  },
  drop: Fo
};
$e(An, {
  pluginName: "revertOnSpill"
});
function kn() {
}
kn.prototype = {
  onSpill: function(e) {
    var n = e.dragEl, o = e.putSortable, r = o || this.sortable;
    r.captureAnimationState(), n.parentNode && n.parentNode.removeChild(n), r.animateAll();
  },
  drop: Fo
};
$e(kn, {
  pluginName: "removeOnSpill"
});
L.mount(new Nr());
L.mount(kn, An);
function Rr() {
  return typeof window < "u" ? window.console : global.console;
}
const Yr = Rr();
function jr(t) {
  const e = /* @__PURE__ */ Object.create(null);
  return function(o) {
    return e[o] || (e[o] = t(o));
  };
}
const Vr = /-(\w)/g, ao = jr((t) => t.replace(Vr, (e, n) => n ? n.toUpperCase() : ""));
function dn(t) {
  t.parentElement !== null && t.parentElement.removeChild(t);
}
function lo(t, e, n) {
  const o = n === 0 ? t.children[0] : t.children[n - 1].nextSibling;
  t.insertBefore(e, o);
}
function Hr(t, e) {
  return Object.values(t).indexOf(e);
}
function Wr(t, e, n, o) {
  if (!t)
    return [];
  const r = Object.values(t), i = e.length - o;
  return [...e].map((l, s) => s >= i ? r.length : r.indexOf(l));
}
function $o(t, e) {
  this.$nextTick(() => this.$emit(t.toLowerCase(), e));
}
function Ur(t) {
  return (e) => {
    this.realList !== null && this["onDrag" + t](e), $o.call(this, t, e);
  };
}
function zr(t) {
  return ["transition-group", "TransitionGroup"].includes(t);
}
function Xr(t) {
  if (!t || t.length !== 1)
    return !1;
  const [{ type: e }] = t;
  return e ? zr(e.name) : !1;
}
function qr(t, e) {
  return e ? { ...e.props, ...e.attrs } : t;
}
const Tn = ["Start", "Add", "Remove", "Update", "End"], Cn = ["Choose", "Unchoose", "Sort", "Filter", "Clone"], Gr = ["Move", ...Tn, ...Cn].map((t) => "on" + t);
let fn = null;
const Jr = {
  options: Object,
  list: {
    type: Array,
    required: !1,
    default: null
  },
  noTransitionOnDrag: {
    type: Boolean,
    default: !1
  },
  clone: {
    type: Function,
    default: (t) => t
  },
  tag: {
    type: String,
    default: "div"
  },
  move: {
    type: Function,
    default: null
  },
  componentData: {
    type: Object,
    required: !1,
    default: null
  },
  component: {
    type: String,
    default: null
  },
  modelValue: {
    type: Array,
    required: !1,
    default: null
  }
}, Kr = bt({
  name: "VueDraggableNext",
  inheritAttrs: !1,
  emits: [
    "update:modelValue",
    "move",
    "change",
    ...Tn.map((t) => t.toLowerCase()),
    ...Cn.map((t) => t.toLowerCase())
  ],
  props: Jr,
  data() {
    return {
      transitionMode: !1,
      noneFunctionalComponentMode: !1,
      headerOffset: 0,
      footerOffset: 0,
      _sortable: {},
      visibleIndexes: [],
      context: {}
    };
  },
  render() {
    const t = this.$slots.default ? this.$slots.default() : null, e = qr(this.$attrs, this.componentData);
    return t ? (this.transitionMode = Xr(t), Xn(this.getTag(), e, t)) : Xn(this.getTag(), e, []);
  },
  created() {
    this.list !== null && this.modelValue !== null && Yr.error("list props are mutually exclusive! Please set one.");
  },
  mounted() {
    const t = {};
    Tn.forEach((r) => {
      t["on" + r] = Ur.call(this, r);
    }), Cn.forEach((r) => {
      t["on" + r] = $o.bind(this, r);
    });
    const e = Object.keys(this.$attrs).reduce((r, i) => (r[ao(i)] = this.$attrs[i], r), {}), n = Object.assign({}, e, t, {
      onMove: (r, i) => this.onDragMove(r, i)
    });
    !("draggable" in n) && (n.draggable = ">*");
    const o = this.$el.nodeType === 1 ? this.$el : this.$el.parentElement;
    this._sortable = new L(o, n), o.__draggable_component__ = this, this.computeIndexes();
  },
  beforeUnmount() {
    try {
      this._sortable !== void 0 && this._sortable.destroy();
    } catch {
    }
  },
  computed: {
    realList() {
      return this.list ? this.list : this.modelValue;
    }
  },
  watch: {
    $attrs: {
      handler(t) {
        this.updateOptions(t);
      },
      deep: !0
    },
    realList() {
      this.computeIndexes();
    }
  },
  methods: {
    getTag() {
      return this.component ? Xo(this.component) : this.tag;
    },
    updateOptions(t) {
      for (var e in t) {
        const n = ao(e);
        Gr.indexOf(n) === -1 && this._sortable.option(n, t[e]);
      }
    },
    getChildrenNodes() {
      return this.$el.children;
    },
    computeIndexes() {
      this.$nextTick(() => {
        this.visibleIndexes = Wr(this.getChildrenNodes(), this.$el.children, this.transitionMode, this.footerOffset);
      });
    },
    getUnderlyingVm(t) {
      const e = Hr(this.getChildrenNodes() || [], t);
      if (e === -1)
        return null;
      const n = this.realList[e];
      return { index: e, element: n };
    },
    emitChanges(t) {
      this.$nextTick(() => {
        this.$emit("change", t);
      });
    },
    alterList(t) {
      if (this.list) {
        t(this.list);
        return;
      }
      const e = [...this.modelValue];
      t(e), this.$emit("update:modelValue", e);
    },
    spliceList() {
      const t = (e) => e.splice(...arguments);
      this.alterList(t);
    },
    updatePosition(t, e) {
      const n = (o) => o.splice(e, 0, o.splice(t, 1)[0]);
      this.alterList(n);
    },
    getVmIndex(t) {
      const e = this.visibleIndexes, n = e.length;
      return t > n - 1 ? n : e[t];
    },
    getComponent() {
      return this.$slots.default ? (
        //@ts-ignore
        this.$slots.default()[0].componentInstance
      ) : null;
    },
    resetTransitionData(t) {
      if (!this.noTransitionOnDrag || !this.transitionMode)
        return;
      var e = this.getChildrenNodes();
      e[t].data = null;
      const n = this.getComponent();
      n.children = [], n.kept = void 0;
    },
    onDragStart(t) {
      this.computeIndexes(), this.context = this.getUnderlyingVm(t.item), this.context && (t.item._underlying_vm_ = this.clone(this.context.element), fn = t.item);
    },
    onDragAdd(t) {
      const e = t.item._underlying_vm_;
      if (e === void 0)
        return;
      dn(t.item);
      const n = this.getVmIndex(t.newIndex);
      this.spliceList(n, 0, e), this.computeIndexes();
      const o = { element: e, newIndex: n };
      this.emitChanges({ added: o });
    },
    onDragRemove(t) {
      if (lo(this.$el, t.item, t.oldIndex), t.pullMode === "clone") {
        dn(t.clone);
        return;
      }
      if (!this.context)
        return;
      const e = this.context.index;
      this.spliceList(e, 1);
      const n = { element: this.context.element, oldIndex: e };
      this.resetTransitionData(e), this.emitChanges({ removed: n });
    },
    onDragUpdate(t) {
      dn(t.item), lo(t.from, t.item, t.oldIndex);
      const e = this.context.index, n = this.getVmIndex(t.newIndex);
      this.updatePosition(e, n);
      const o = { element: this.context.element, oldIndex: e, newIndex: n };
      this.emitChanges({ moved: o });
    },
    updateProperty(t, e) {
      t.hasOwnProperty(e) && (t[e] += this.headerOffset);
    },
    onDragMove(t, e) {
      const n = this.move;
      if (!n || !this.realList)
        return !0;
      const o = this.getRelatedContextFromMoveEvent(t), r = this.context, i = this.computeFutureIndex(o, t);
      Object.assign(r, { futureIndex: i });
      const a = Object.assign({}, t, {
        relatedContext: o,
        draggedContext: r
      });
      return n(a, e);
    },
    onDragEnd() {
      this.computeIndexes(), fn = null;
    },
    getTrargetedComponent(t) {
      return t.__draggable_component__;
    },
    getRelatedContextFromMoveEvent({ to: t, related: e }) {
      const n = this.getTrargetedComponent(t);
      if (!n)
        return { component: n };
      const o = n.realList, r = { list: o, component: n };
      if (t !== e && o && n.getUnderlyingVm) {
        const i = n.getUnderlyingVm(e);
        if (i)
          return Object.assign(i, r);
      }
      return r;
    },
    computeFutureIndex(t, e) {
      const n = [...e.to.children].filter((a) => a.style.display !== "none");
      if (n.length === 0)
        return 0;
      const o = n.indexOf(e.related), r = t.component.getVmIndex(o);
      return n.indexOf(fn) !== -1 || !e.willInsertAfter ? r : r + 1;
    }
  }
});
function Dn(t, e, n) {
  var o, r, i, a, l;
  e == null && (e = 100);
  function s() {
    var d = Date.now() - a;
    d < e && d >= 0 ? o = setTimeout(s, e - d) : (o = null, n || (l = t.apply(i, r), i = r = null));
  }
  var c = function() {
    i = this, r = arguments, a = Date.now();
    var d = n && !o;
    return o || (o = setTimeout(s, e)), d && (l = t.apply(i, r), i = r = null), l;
  };
  return c.clear = function() {
    o && (clearTimeout(o), o = null);
  }, c.flush = function() {
    o && (l = t.apply(i, r), i = r = null, clearTimeout(o), o = null);
  }, c;
}
Dn.debounce = Dn;
var pn = Dn;
function Qr(t, e, n) {
  er(t) ? vt(t, (o, r) => {
    r == null || r.removeEventListener(e, n), o == null || o.addEventListener(e, n);
  }) : yt(() => {
    t.addEventListener(e, n);
  }), qt(() => {
    var o;
    (o = ee(t)) === null || o === void 0 || o.removeEventListener(e, n);
  });
}
function Zr(t, e) {
  const n = "pointerdown";
  return typeof window > "u" || !window ? void 0 : Qr(window, n, (r) => {
    const i = ee(t);
    i && (i === r.target || r.composedPath().includes(i) || e(r));
  });
}
function ei(t, e, n) {
  let o = null;
  const r = ue(!1);
  yt(() => {
    (t.content !== void 0 || n.value) && (r.value = !0), o = new MutationObserver(i), o.observe(e.value, {
      childList: !0,
      subtree: !0
    });
  }), qt(() => o.disconnect()), vt(n, (a) => {
    a ? r.value = !0 : r.value = !1;
  });
  const i = () => {
    t.content ? r.value = !0 : r.value = !1;
  };
  return {
    hasContent: r
  };
}
function et(t, e) {
  var n = t.getBoundingClientRect(), o = 1, r = 1;
  return {
    width: n.width / o,
    height: n.height / r,
    top: n.top / r,
    right: n.right / o,
    bottom: n.bottom / r,
    left: n.left / o,
    x: n.left / o,
    y: n.top / r
  };
}
function Ce(t) {
  if (t == null)
    return window;
  if (t.toString() !== "[object Window]") {
    var e = t.ownerDocument;
    return e && e.defaultView || window;
  }
  return t;
}
function Fn(t) {
  var e = Ce(t), n = e.pageXOffset, o = e.pageYOffset;
  return {
    scrollLeft: n,
    scrollTop: o
  };
}
function ht(t) {
  var e = Ce(t).Element;
  return t instanceof e || t instanceof Element;
}
function me(t) {
  var e = Ce(t).HTMLElement;
  return t instanceof e || t instanceof HTMLElement;
}
function Lo(t) {
  if (typeof ShadowRoot > "u")
    return !1;
  var e = Ce(t).ShadowRoot;
  return t instanceof e || t instanceof ShadowRoot;
}
function ti(t) {
  return {
    scrollLeft: t.scrollLeft,
    scrollTop: t.scrollTop
  };
}
function ni(t) {
  return t === Ce(t) || !me(t) ? Fn(t) : ti(t);
}
function Ae(t) {
  return t ? (t.nodeName || "").toLowerCase() : null;
}
function je(t) {
  return ((ht(t) ? t.ownerDocument : (
    // $FlowFixMe[prop-missing]
    t.document
  )) || window.document).documentElement;
}
function $n(t) {
  return et(je(t)).left + Fn(t).scrollLeft;
}
function Le(t) {
  return Ce(t).getComputedStyle(t);
}
function Ln(t) {
  var e = Le(t), n = e.overflow, o = e.overflowX, r = e.overflowY;
  return /auto|scroll|overlay|hidden/.test(n + r + o);
}
function oi(t) {
  var e = t.getBoundingClientRect(), n = e.width / t.offsetWidth || 1, o = e.height / t.offsetHeight || 1;
  return n !== 1 || o !== 1;
}
function ri(t, e, n) {
  n === void 0 && (n = !1);
  var o = me(e);
  me(e) && oi(e);
  var r = je(e), i = et(t), a = {
    scrollLeft: 0,
    scrollTop: 0
  }, l = {
    x: 0,
    y: 0
  };
  return (o || !o && !n) && ((Ae(e) !== "body" || // https://github.com/popperjs/popper-core/issues/1078
  Ln(r)) && (a = ni(e)), me(e) ? (l = et(e), l.x += e.clientLeft, l.y += e.clientTop) : r && (l.x = $n(r))), {
    x: i.left + a.scrollLeft - l.x,
    y: i.top + a.scrollTop - l.y,
    width: i.width,
    height: i.height
  };
}
function In(t) {
  var e = et(t), n = t.offsetWidth, o = t.offsetHeight;
  return Math.abs(e.width - n) <= 1 && (n = e.width), Math.abs(e.height - o) <= 1 && (o = e.height), {
    x: t.offsetLeft,
    y: t.offsetTop,
    width: n,
    height: o
  };
}
function Kt(t) {
  return Ae(t) === "html" ? t : (
    // this is a quicker (but less type safe) way to save quite some bytes from the bundle
    // $FlowFixMe[incompatible-return]
    // $FlowFixMe[prop-missing]
    t.assignedSlot || // step into the shadow DOM of the parent of a slotted node
    t.parentNode || // DOM Element detected
    (Lo(t) ? t.host : null) || // ShadowRoot detected
    // $FlowFixMe[incompatible-call]: HTMLElement is a Node
    je(t)
  );
}
function Io(t) {
  return ["html", "body", "#document"].indexOf(Ae(t)) >= 0 ? t.ownerDocument.body : me(t) && Ln(t) ? t : Io(Kt(t));
}
function pt(t, e) {
  var n;
  e === void 0 && (e = []);
  var o = Io(t), r = o === ((n = t.ownerDocument) == null ? void 0 : n.body), i = Ce(o), a = r ? [i].concat(i.visualViewport || [], Ln(o) ? o : []) : o, l = e.concat(a);
  return r ? l : (
    // $FlowFixMe[incompatible-call]: isBody tells us target will be an HTMLElement here
    l.concat(pt(Kt(a)))
  );
}
function ii(t) {
  return ["table", "td", "th"].indexOf(Ae(t)) >= 0;
}
function so(t) {
  return !me(t) || // https://github.com/popperjs/popper-core/issues/837
  Le(t).position === "fixed" ? null : t.offsetParent;
}
function ai(t) {
  var e = navigator.userAgent.toLowerCase().indexOf("firefox") !== -1, n = navigator.userAgent.indexOf("Trident") !== -1;
  if (n && me(t)) {
    var o = Le(t);
    if (o.position === "fixed")
      return null;
  }
  for (var r = Kt(t); me(r) && ["html", "body"].indexOf(Ae(r)) < 0; ) {
    var i = Le(r);
    if (i.transform !== "none" || i.perspective !== "none" || i.contain === "paint" || ["transform", "perspective"].indexOf(i.willChange) !== -1 || e && i.willChange === "filter" || e && i.filter && i.filter !== "none")
      return r;
    r = r.parentNode;
  }
  return null;
}
function Tt(t) {
  for (var e = Ce(t), n = so(t); n && ii(n) && Le(n).position === "static"; )
    n = so(n);
  return n && (Ae(n) === "html" || Ae(n) === "body" && Le(n).position === "static") ? e : n || ai(t) || e;
}
var be = "top", _e = "bottom", Te = "right", ye = "left", Mn = "auto", Ct = [be, _e, Te, ye], tt = "start", gt = "end", li = "clippingParents", Mo = "viewport", ot = "popper", si = "reference", uo = /* @__PURE__ */ Ct.reduce(function(t, e) {
  return t.concat([e + "-" + tt, e + "-" + gt]);
}, []), Po = /* @__PURE__ */ [].concat(Ct, [Mn]).reduce(function(t, e) {
  return t.concat([e, e + "-" + tt, e + "-" + gt]);
}, []), ui = "beforeRead", ci = "read", di = "afterRead", fi = "beforeMain", pi = "main", vi = "afterMain", hi = "beforeWrite", gi = "write", mi = "afterWrite", bi = [ui, ci, di, fi, pi, vi, hi, gi, mi];
function yi(t) {
  var e = /* @__PURE__ */ new Map(), n = /* @__PURE__ */ new Set(), o = [];
  t.forEach(function(i) {
    e.set(i.name, i);
  });
  function r(i) {
    n.add(i.name);
    var a = [].concat(i.requires || [], i.requiresIfExists || []);
    a.forEach(function(l) {
      if (!n.has(l)) {
        var s = e.get(l);
        s && r(s);
      }
    }), o.push(i);
  }
  return t.forEach(function(i) {
    n.has(i.name) || r(i);
  }), o;
}
function wi(t) {
  var e = yi(t);
  return bi.reduce(function(n, o) {
    return n.concat(e.filter(function(r) {
      return r.phase === o;
    }));
  }, []);
}
function _i(t) {
  var e;
  return function() {
    return e || (e = new Promise(function(n) {
      Promise.resolve().then(function() {
        e = void 0, n(t());
      });
    })), e;
  };
}
function Se(t) {
  return t.split("-")[0];
}
function Ti(t) {
  var e = t.reduce(function(n, o) {
    var r = n[o.name];
    return n[o.name] = r ? Object.assign({}, r, o, {
      options: Object.assign({}, r.options, o.options),
      data: Object.assign({}, r.data, o.data)
    }) : o, n;
  }, {});
  return Object.keys(e).map(function(n) {
    return e[n];
  });
}
function Ci(t) {
  var e = Ce(t), n = je(t), o = e.visualViewport, r = n.clientWidth, i = n.clientHeight, a = 0, l = 0;
  return o && (r = o.width, i = o.height, /^((?!chrome|android).)*safari/i.test(navigator.userAgent) || (a = o.offsetLeft, l = o.offsetTop)), {
    width: r,
    height: i,
    x: a + $n(t),
    y: l
  };
}
var Ye = Math.max, mt = Math.min, $t = Math.round;
function Di(t) {
  var e, n = je(t), o = Fn(t), r = (e = t.ownerDocument) == null ? void 0 : e.body, i = Ye(n.scrollWidth, n.clientWidth, r ? r.scrollWidth : 0, r ? r.clientWidth : 0), a = Ye(n.scrollHeight, n.clientHeight, r ? r.scrollHeight : 0, r ? r.clientHeight : 0), l = -o.scrollLeft + $n(t), s = -o.scrollTop;
  return Le(r || n).direction === "rtl" && (l += Ye(n.clientWidth, r ? r.clientWidth : 0) - i), {
    width: i,
    height: a,
    x: l,
    y: s
  };
}
function Bo(t, e) {
  var n = e.getRootNode && e.getRootNode();
  if (t.contains(e))
    return !0;
  if (n && Lo(n)) {
    var o = e;
    do {
      if (o && t.isSameNode(o))
        return !0;
      o = o.parentNode || o.host;
    } while (o);
  }
  return !1;
}
function En(t) {
  return Object.assign({}, t, {
    left: t.x,
    top: t.y,
    right: t.x + t.width,
    bottom: t.y + t.height
  });
}
function Ei(t) {
  var e = et(t);
  return e.top = e.top + t.clientTop, e.left = e.left + t.clientLeft, e.bottom = e.top + t.clientHeight, e.right = e.left + t.clientWidth, e.width = t.clientWidth, e.height = t.clientHeight, e.x = e.left, e.y = e.top, e;
}
function co(t, e) {
  return e === Mo ? En(Ci(t)) : me(e) ? Ei(e) : En(Di(je(t)));
}
function xi(t) {
  var e = pt(Kt(t)), n = ["absolute", "fixed"].indexOf(Le(t).position) >= 0, o = n && me(t) ? Tt(t) : t;
  return ht(o) ? e.filter(function(r) {
    return ht(r) && Bo(r, o) && Ae(r) !== "body";
  }) : [];
}
function Si(t, e, n) {
  var o = e === "clippingParents" ? xi(t) : [].concat(e), r = [].concat(o, [n]), i = r[0], a = r.reduce(function(l, s) {
    var c = co(t, s);
    return l.top = Ye(c.top, l.top), l.right = mt(c.right, l.right), l.bottom = mt(c.bottom, l.bottom), l.left = Ye(c.left, l.left), l;
  }, co(t, i));
  return a.width = a.right - a.left, a.height = a.bottom - a.top, a.x = a.left, a.y = a.top, a;
}
function nt(t) {
  return t.split("-")[1];
}
function Pn(t) {
  return ["top", "bottom"].indexOf(t) >= 0 ? "x" : "y";
}
function No(t) {
  var e = t.reference, n = t.element, o = t.placement, r = o ? Se(o) : null, i = o ? nt(o) : null, a = e.x + e.width / 2 - n.width / 2, l = e.y + e.height / 2 - n.height / 2, s;
  switch (r) {
    case be:
      s = {
        x: a,
        y: e.y - n.height
      };
      break;
    case _e:
      s = {
        x: a,
        y: e.y + e.height
      };
      break;
    case Te:
      s = {
        x: e.x + e.width,
        y: l
      };
      break;
    case ye:
      s = {
        x: e.x - n.width,
        y: l
      };
      break;
    default:
      s = {
        x: e.x,
        y: e.y
      };
  }
  var c = r ? Pn(r) : null;
  if (c != null) {
    var d = c === "y" ? "height" : "width";
    switch (i) {
      case tt:
        s[c] = s[c] - (e[d] / 2 - n[d] / 2);
        break;
      case gt:
        s[c] = s[c] + (e[d] / 2 - n[d] / 2);
        break;
    }
  }
  return s;
}
function Ro() {
  return {
    top: 0,
    right: 0,
    bottom: 0,
    left: 0
  };
}
function Yo(t) {
  return Object.assign({}, Ro(), t);
}
function jo(t, e) {
  return e.reduce(function(n, o) {
    return n[o] = t, n;
  }, {});
}
function Bn(t, e) {
  e === void 0 && (e = {});
  var n = e, o = n.placement, r = o === void 0 ? t.placement : o, i = n.boundary, a = i === void 0 ? li : i, l = n.rootBoundary, s = l === void 0 ? Mo : l, c = n.elementContext, d = c === void 0 ? ot : c, u = n.altBoundary, b = u === void 0 ? !1 : u, y = n.padding, h = y === void 0 ? 0 : y, g = Yo(typeof h != "number" ? h : jo(h, Ct)), f = d === ot ? si : ot, D = t.rects.popper, x = t.elements[b ? f : d], w = Si(ht(x) ? x : x.contextElement || je(t.elements.popper), a, s), T = et(t.elements.reference), S = No({
    reference: T,
    element: D,
    strategy: "absolute",
    placement: r
  }), F = En(Object.assign({}, D, S)), m = d === ot ? F : T, C = {
    top: w.top - m.top + g.top,
    bottom: m.bottom - w.bottom + g.bottom,
    left: w.left - m.left + g.left,
    right: m.right - w.right + g.right
  }, v = t.modifiersData.offset;
  if (d === ot && v) {
    var E = v[r];
    Object.keys(C).forEach(function(O) {
      var V = [Te, _e].indexOf(O) >= 0 ? 1 : -1, k = [be, _e].indexOf(O) >= 0 ? "y" : "x";
      C[O] += E[k] * V;
    });
  }
  return C;
}
var fo = {
  placement: "bottom",
  modifiers: [],
  strategy: "absolute"
};
function po() {
  for (var t = arguments.length, e = new Array(t), n = 0; n < t; n++)
    e[n] = arguments[n];
  return !e.some(function(o) {
    return !(o && typeof o.getBoundingClientRect == "function");
  });
}
function Oi(t) {
  t === void 0 && (t = {});
  var e = t, n = e.defaultModifiers, o = n === void 0 ? [] : n, r = e.defaultOptions, i = r === void 0 ? fo : r;
  return function(l, s, c) {
    c === void 0 && (c = i);
    var d = {
      placement: "bottom",
      orderedModifiers: [],
      options: Object.assign({}, fo, i),
      modifiersData: {},
      elements: {
        reference: l,
        popper: s
      },
      attributes: {},
      styles: {}
    }, u = [], b = !1, y = {
      state: d,
      setOptions: function(D) {
        var x = typeof D == "function" ? D(d.options) : D;
        g(), d.options = Object.assign({}, i, d.options, x), d.scrollParents = {
          reference: ht(l) ? pt(l) : l.contextElement ? pt(l.contextElement) : [],
          popper: pt(s)
        };
        var w = wi(Ti([].concat(o, d.options.modifiers)));
        return d.orderedModifiers = w.filter(function(T) {
          return T.enabled;
        }), h(), y.update();
      },
      // Sync update – it will always be executed, even if not necessary. This
      // is useful for low frequency updates where sync behavior simplifies the
      // logic.
      // For high frequency updates (e.g. `resize` and `scroll` events), always
      // prefer the async Popper#update method
      forceUpdate: function() {
        if (!b) {
          var D = d.elements, x = D.reference, w = D.popper;
          if (po(x, w)) {
            d.rects = {
              reference: ri(x, Tt(w), d.options.strategy === "fixed"),
              popper: In(w)
            }, d.reset = !1, d.placement = d.options.placement, d.orderedModifiers.forEach(function(E) {
              return d.modifiersData[E.name] = Object.assign({}, E.data);
            });
            for (var T = 0; T < d.orderedModifiers.length; T++) {
              if (d.reset === !0) {
                d.reset = !1, T = -1;
                continue;
              }
              var S = d.orderedModifiers[T], F = S.fn, m = S.options, C = m === void 0 ? {} : m, v = S.name;
              typeof F == "function" && (d = F({
                state: d,
                options: C,
                name: v,
                instance: y
              }) || d);
            }
          }
        }
      },
      // Async and optimistically optimized update – it will not be executed if
      // not necessary (debounced to run at most once-per-tick)
      update: _i(function() {
        return new Promise(function(f) {
          y.forceUpdate(), f(d);
        });
      }),
      destroy: function() {
        g(), b = !0;
      }
    };
    if (!po(l, s))
      return y;
    y.setOptions(c).then(function(f) {
      !b && c.onFirstUpdate && c.onFirstUpdate(f);
    });
    function h() {
      d.orderedModifiers.forEach(function(f) {
        var D = f.name, x = f.options, w = x === void 0 ? {} : x, T = f.effect;
        if (typeof T == "function") {
          var S = T({
            state: d,
            name: D,
            instance: y,
            options: w
          }), F = function() {
          };
          u.push(S || F);
        }
      });
    }
    function g() {
      u.forEach(function(f) {
        return f();
      }), u = [];
    }
    return y;
  };
}
var Lt = {
  passive: !0
};
function Ai(t) {
  var e = t.state, n = t.instance, o = t.options, r = o.scroll, i = r === void 0 ? !0 : r, a = o.resize, l = a === void 0 ? !0 : a, s = Ce(e.elements.popper), c = [].concat(e.scrollParents.reference, e.scrollParents.popper);
  return i && c.forEach(function(d) {
    d.addEventListener("scroll", n.update, Lt);
  }), l && s.addEventListener("resize", n.update, Lt), function() {
    i && c.forEach(function(d) {
      d.removeEventListener("scroll", n.update, Lt);
    }), l && s.removeEventListener("resize", n.update, Lt);
  };
}
var ki = {
  name: "eventListeners",
  enabled: !0,
  phase: "write",
  fn: function() {
  },
  effect: Ai,
  data: {}
};
function Fi(t) {
  var e = t.state, n = t.name;
  e.modifiersData[n] = No({
    reference: e.rects.reference,
    element: e.rects.popper,
    strategy: "absolute",
    placement: e.placement
  });
}
var $i = {
  name: "popperOffsets",
  enabled: !0,
  phase: "read",
  fn: Fi,
  data: {}
}, Li = {
  top: "auto",
  right: "auto",
  bottom: "auto",
  left: "auto"
};
function Ii(t) {
  var e = t.x, n = t.y, o = window, r = o.devicePixelRatio || 1;
  return {
    x: $t($t(e * r) / r) || 0,
    y: $t($t(n * r) / r) || 0
  };
}
function vo(t) {
  var e, n = t.popper, o = t.popperRect, r = t.placement, i = t.variation, a = t.offsets, l = t.position, s = t.gpuAcceleration, c = t.adaptive, d = t.roundOffsets, u = d === !0 ? Ii(a) : typeof d == "function" ? d(a) : a, b = u.x, y = b === void 0 ? 0 : b, h = u.y, g = h === void 0 ? 0 : h, f = a.hasOwnProperty("x"), D = a.hasOwnProperty("y"), x = ye, w = be, T = window;
  if (c) {
    var S = Tt(n), F = "clientHeight", m = "clientWidth";
    S === Ce(n) && (S = je(n), Le(S).position !== "static" && l === "absolute" && (F = "scrollHeight", m = "scrollWidth")), S = S, (r === be || (r === ye || r === Te) && i === gt) && (w = _e, g -= S[F] - o.height, g *= s ? 1 : -1), (r === ye || (r === be || r === _e) && i === gt) && (x = Te, y -= S[m] - o.width, y *= s ? 1 : -1);
  }
  var C = Object.assign({
    position: l
  }, c && Li);
  if (s) {
    var v;
    return Object.assign({}, C, (v = {}, v[w] = D ? "0" : "", v[x] = f ? "0" : "", v.transform = (T.devicePixelRatio || 1) <= 1 ? "translate(" + y + "px, " + g + "px)" : "translate3d(" + y + "px, " + g + "px, 0)", v));
  }
  return Object.assign({}, C, (e = {}, e[w] = D ? g + "px" : "", e[x] = f ? y + "px" : "", e.transform = "", e));
}
function Mi(t) {
  var e = t.state, n = t.options, o = n.gpuAcceleration, r = o === void 0 ? !0 : o, i = n.adaptive, a = i === void 0 ? !0 : i, l = n.roundOffsets, s = l === void 0 ? !0 : l, c = {
    placement: Se(e.placement),
    variation: nt(e.placement),
    popper: e.elements.popper,
    popperRect: e.rects.popper,
    gpuAcceleration: r
  };
  e.modifiersData.popperOffsets != null && (e.styles.popper = Object.assign({}, e.styles.popper, vo(Object.assign({}, c, {
    offsets: e.modifiersData.popperOffsets,
    position: e.options.strategy,
    adaptive: a,
    roundOffsets: s
  })))), e.modifiersData.arrow != null && (e.styles.arrow = Object.assign({}, e.styles.arrow, vo(Object.assign({}, c, {
    offsets: e.modifiersData.arrow,
    position: "absolute",
    adaptive: !1,
    roundOffsets: s
  })))), e.attributes.popper = Object.assign({}, e.attributes.popper, {
    "data-popper-placement": e.placement
  });
}
var Pi = {
  name: "computeStyles",
  enabled: !0,
  phase: "beforeWrite",
  fn: Mi,
  data: {}
};
function Bi(t) {
  var e = t.state;
  Object.keys(e.elements).forEach(function(n) {
    var o = e.styles[n] || {}, r = e.attributes[n] || {}, i = e.elements[n];
    !me(i) || !Ae(i) || (Object.assign(i.style, o), Object.keys(r).forEach(function(a) {
      var l = r[a];
      l === !1 ? i.removeAttribute(a) : i.setAttribute(a, l === !0 ? "" : l);
    }));
  });
}
function Ni(t) {
  var e = t.state, n = {
    popper: {
      position: e.options.strategy,
      left: "0",
      top: "0",
      margin: "0"
    },
    arrow: {
      position: "absolute"
    },
    reference: {}
  };
  return Object.assign(e.elements.popper.style, n.popper), e.styles = n, e.elements.arrow && Object.assign(e.elements.arrow.style, n.arrow), function() {
    Object.keys(e.elements).forEach(function(o) {
      var r = e.elements[o], i = e.attributes[o] || {}, a = Object.keys(e.styles.hasOwnProperty(o) ? e.styles[o] : n[o]), l = a.reduce(function(s, c) {
        return s[c] = "", s;
      }, {});
      !me(r) || !Ae(r) || (Object.assign(r.style, l), Object.keys(i).forEach(function(s) {
        r.removeAttribute(s);
      }));
    });
  };
}
var Ri = {
  name: "applyStyles",
  enabled: !0,
  phase: "write",
  fn: Bi,
  effect: Ni,
  requires: ["computeStyles"]
}, Yi = [ki, $i, Pi, Ri], ji = /* @__PURE__ */ Oi({
  defaultModifiers: Yi
});
function Vi(t) {
  return t === "x" ? "y" : "x";
}
function Yt(t, e, n) {
  return Ye(t, mt(e, n));
}
function Hi(t) {
  var e = t.state, n = t.options, o = t.name, r = n.mainAxis, i = r === void 0 ? !0 : r, a = n.altAxis, l = a === void 0 ? !1 : a, s = n.boundary, c = n.rootBoundary, d = n.altBoundary, u = n.padding, b = n.tether, y = b === void 0 ? !0 : b, h = n.tetherOffset, g = h === void 0 ? 0 : h, f = Bn(e, {
    boundary: s,
    rootBoundary: c,
    padding: u,
    altBoundary: d
  }), D = Se(e.placement), x = nt(e.placement), w = !x, T = Pn(D), S = Vi(T), F = e.modifiersData.popperOffsets, m = e.rects.reference, C = e.rects.popper, v = typeof g == "function" ? g(Object.assign({}, e.rects, {
    placement: e.placement
  })) : g, E = {
    x: 0,
    y: 0
  };
  if (F) {
    if (i || l) {
      var O = T === "y" ? be : ye, V = T === "y" ? _e : Te, k = T === "y" ? "height" : "width", H = F[T], ie = F[T] + f[O], W = F[T] - f[V], le = y ? -C[k] / 2 : 0, U = x === tt ? m[k] : C[k], J = x === tt ? -C[k] : -m[k], K = e.elements.arrow, ve = y && K ? In(K) : {
        width: 0,
        height: 0
      }, Me = e.modifiersData["arrow#persistent"] ? e.modifiersData["arrow#persistent"].padding : Ro(), Et = Me[O], Ve = Me[V], De = Yt(0, m[k], ve[k]), xt = w ? m[k] / 2 - le - De - Et - v : U - De - Et - v, Qt = w ? -m[k] / 2 + le + De + Ve + v : J + De + Ve + v, Xe = e.elements.arrow && Tt(e.elements.arrow), Zt = Xe ? T === "y" ? Xe.clientTop || 0 : Xe.clientLeft || 0 : 0, Yn = e.modifiersData.offset ? e.modifiersData.offset[e.placement][T] : 0, jn = F[T] + xt - Yn - Zt, Vn = F[T] + Qt - Yn;
      if (i) {
        var Hn = Yt(y ? mt(ie, jn) : ie, H, y ? Ye(W, Vn) : W);
        F[T] = Hn, E[T] = Hn - H;
      }
      if (l) {
        var Uo = T === "x" ? be : ye, zo = T === "x" ? _e : Te, St = F[S], Wn = St + f[Uo], Un = St - f[zo], zn = Yt(y ? mt(Wn, jn) : Wn, St, y ? Ye(Un, Vn) : Un);
        F[S] = zn, E[S] = zn - St;
      }
    }
    e.modifiersData[o] = E;
  }
}
var Wi = {
  name: "preventOverflow",
  enabled: !0,
  phase: "main",
  fn: Hi,
  requiresIfExists: ["offset"]
}, Ui = {
  left: "right",
  right: "left",
  bottom: "top",
  top: "bottom"
};
function jt(t) {
  return t.replace(/left|right|bottom|top/g, function(e) {
    return Ui[e];
  });
}
var zi = {
  start: "end",
  end: "start"
};
function ho(t) {
  return t.replace(/start|end/g, function(e) {
    return zi[e];
  });
}
function Xi(t, e) {
  e === void 0 && (e = {});
  var n = e, o = n.placement, r = n.boundary, i = n.rootBoundary, a = n.padding, l = n.flipVariations, s = n.allowedAutoPlacements, c = s === void 0 ? Po : s, d = nt(o), u = d ? l ? uo : uo.filter(function(h) {
    return nt(h) === d;
  }) : Ct, b = u.filter(function(h) {
    return c.indexOf(h) >= 0;
  });
  b.length === 0 && (b = u);
  var y = b.reduce(function(h, g) {
    return h[g] = Bn(t, {
      placement: g,
      boundary: r,
      rootBoundary: i,
      padding: a
    })[Se(g)], h;
  }, {});
  return Object.keys(y).sort(function(h, g) {
    return y[h] - y[g];
  });
}
function qi(t) {
  if (Se(t) === Mn)
    return [];
  var e = jt(t);
  return [ho(t), e, ho(e)];
}
function Gi(t) {
  var e = t.state, n = t.options, o = t.name;
  if (!e.modifiersData[o]._skip) {
    for (var r = n.mainAxis, i = r === void 0 ? !0 : r, a = n.altAxis, l = a === void 0 ? !0 : a, s = n.fallbackPlacements, c = n.padding, d = n.boundary, u = n.rootBoundary, b = n.altBoundary, y = n.flipVariations, h = y === void 0 ? !0 : y, g = n.allowedAutoPlacements, f = e.options.placement, D = Se(f), x = D === f, w = s || (x || !h ? [jt(f)] : qi(f)), T = [f].concat(w).reduce(function(Ve, De) {
      return Ve.concat(Se(De) === Mn ? Xi(e, {
        placement: De,
        boundary: d,
        rootBoundary: u,
        padding: c,
        flipVariations: h,
        allowedAutoPlacements: g
      }) : De);
    }, []), S = e.rects.reference, F = e.rects.popper, m = /* @__PURE__ */ new Map(), C = !0, v = T[0], E = 0; E < T.length; E++) {
      var O = T[E], V = Se(O), k = nt(O) === tt, H = [be, _e].indexOf(V) >= 0, ie = H ? "width" : "height", W = Bn(e, {
        placement: O,
        boundary: d,
        rootBoundary: u,
        altBoundary: b,
        padding: c
      }), le = H ? k ? Te : ye : k ? _e : be;
      S[ie] > F[ie] && (le = jt(le));
      var U = jt(le), J = [];
      if (i && J.push(W[V] <= 0), l && J.push(W[le] <= 0, W[U] <= 0), J.every(function(Ve) {
        return Ve;
      })) {
        v = O, C = !1;
        break;
      }
      m.set(O, J);
    }
    if (C)
      for (var K = h ? 3 : 1, ve = function(De) {
        var xt = T.find(function(Qt) {
          var Xe = m.get(Qt);
          if (Xe)
            return Xe.slice(0, De).every(function(Zt) {
              return Zt;
            });
        });
        if (xt)
          return v = xt, "break";
      }, Me = K; Me > 0; Me--) {
        var Et = ve(Me);
        if (Et === "break")
          break;
      }
    e.placement !== v && (e.modifiersData[o]._skip = !0, e.placement = v, e.reset = !0);
  }
}
var Ji = {
  name: "flip",
  enabled: !0,
  phase: "main",
  fn: Gi,
  requiresIfExists: ["offset"],
  data: {
    _skip: !1
  }
};
function Ki(t, e, n) {
  var o = Se(t), r = [ye, be].indexOf(o) >= 0 ? -1 : 1, i = typeof n == "function" ? n(Object.assign({}, e, {
    placement: t
  })) : n, a = i[0], l = i[1];
  return a = a || 0, l = (l || 0) * r, [ye, Te].indexOf(o) >= 0 ? {
    x: l,
    y: a
  } : {
    x: a,
    y: l
  };
}
function Qi(t) {
  var e = t.state, n = t.options, o = t.name, r = n.offset, i = r === void 0 ? [0, 0] : r, a = Po.reduce(function(d, u) {
    return d[u] = Ki(u, e.rects, i), d;
  }, {}), l = a[e.placement], s = l.x, c = l.y;
  e.modifiersData.popperOffsets != null && (e.modifiersData.popperOffsets.x += s, e.modifiersData.popperOffsets.y += c), e.modifiersData[o] = a;
}
var Zi = {
  name: "offset",
  enabled: !0,
  phase: "main",
  requires: ["popperOffsets"],
  fn: Qi
}, ea = function(e, n) {
  return e = typeof e == "function" ? e(Object.assign({}, n.rects, {
    placement: n.placement
  })) : e, Yo(typeof e != "number" ? e : jo(e, Ct));
};
function ta(t) {
  var e, n = t.state, o = t.name, r = t.options, i = n.elements.arrow, a = n.modifiersData.popperOffsets, l = Se(n.placement), s = Pn(l), c = [ye, Te].indexOf(l) >= 0, d = c ? "height" : "width";
  if (!(!i || !a)) {
    var u = ea(r.padding, n), b = In(i), y = s === "y" ? be : ye, h = s === "y" ? _e : Te, g = n.rects.reference[d] + n.rects.reference[s] - a[s] - n.rects.popper[d], f = a[s] - n.rects.reference[s], D = Tt(i), x = D ? s === "y" ? D.clientHeight || 0 : D.clientWidth || 0 : 0, w = g / 2 - f / 2, T = u[y], S = x - b[d] - u[h], F = x / 2 - b[d] / 2 + w, m = Yt(T, F, S), C = s;
    n.modifiersData[o] = (e = {}, e[C] = m, e.centerOffset = m - F, e);
  }
}
function na(t) {
  var e = t.state, n = t.options, o = n.element, r = o === void 0 ? "[data-popper-arrow]" : o;
  r != null && (typeof r == "string" && (r = e.elements.popper.querySelector(r), !r) || Bo(e.elements.popper, r) && (e.elements.arrow = r));
}
var oa = {
  name: "arrow",
  enabled: !0,
  phase: "main",
  fn: ta,
  effect: na,
  requires: ["popperOffsets"],
  requiresIfExists: ["preventOverflow"]
};
const vn = (t) => parseInt(t, 10);
function ra({
  arrowPadding: t,
  emit: e,
  locked: n,
  offsetDistance: o,
  offsetSkid: r,
  placement: i,
  popperNode: a,
  triggerNode: l
}) {
  const s = Zo({
    isOpen: !1,
    popperInstance: null
  }), c = (g) => {
    var f;
    (f = s.popperInstance) === null || f === void 0 || f.setOptions((D) => ({
      ...D,
      modifiers: [...D.modifiers, {
        name: "eventListeners",
        enabled: g
      }]
    }));
  }, d = () => c(!0), u = () => c(!1), b = () => {
    s.isOpen && (s.isOpen = !1, e("close:popper"));
  }, y = () => {
    s.isOpen || (s.isOpen = !0, e("open:popper"));
  };
  vt([() => s.isOpen, i], async ([g]) => {
    g ? (await h(), d()) : u();
  });
  const h = async () => {
    await yo(), s.popperInstance = ji(l.value, a.value, {
      placement: i.value,
      modifiers: [Wi, Ji, {
        name: "flip",
        enabled: !n.value
      }, oa, {
        name: "arrow",
        options: {
          padding: vn(t.value)
        }
      }, Zi, {
        name: "offset",
        options: {
          offset: [vn(r.value), vn(o.value)]
        }
      }]
    }), s.popperInstance.update();
  };
  return qt(() => {
    var g;
    (g = s.popperInstance) === null || g === void 0 || g.destroy();
  }), {
    ...mo(s),
    open: y,
    close: b
  };
}
const ia = {
  id: "arrow",
  "data-popper-arrow": ""
};
function aa(t, e) {
  return I(), M("div", ia);
}
function Vo(t, e) {
  e === void 0 && (e = {});
  var n = e.insertAt;
  if (!(!t || typeof document > "u")) {
    var o = document.head || document.getElementsByTagName("head")[0], r = document.createElement("style");
    r.type = "text/css", n === "top" && o.firstChild ? o.insertBefore(r, o.firstChild) : o.appendChild(r), r.styleSheet ? r.styleSheet.cssText = t : r.appendChild(document.createTextNode(t));
  }
}
var la = `
#arrow[data-v-20b7fd4a],
  #arrow[data-v-20b7fd4a]::before {
    transition: background 250ms ease-in-out;
    position: absolute;
    width: calc(10px - var(--popper-theme-border-width, 0px));
    height: calc(10px - var(--popper-theme-border-width, 0px));
    box-sizing: border-box;
    background: var(--popper-theme-background-color);
}
#arrow[data-v-20b7fd4a] {
    visibility: hidden;
}
#arrow[data-v-20b7fd4a]::before {
    visibility: visible;
    content: "";
    transform: rotate(45deg);
}

  /* Top arrow */
.popper[data-popper-placement^="top"] > #arrow[data-v-20b7fd4a] {
    bottom: -5px;
}
.popper[data-popper-placement^="top"] > #arrow[data-v-20b7fd4a]::before {
    border-right: var(--popper-theme-border-width)
      var(--popper-theme-border-style) var(--popper-theme-border-color);
    border-bottom: var(--popper-theme-border-width)
      var(--popper-theme-border-style) var(--popper-theme-border-color);
}

  /* Bottom arrow */
.popper[data-popper-placement^="bottom"] > #arrow[data-v-20b7fd4a] {
    top: -5px;
}
.popper[data-popper-placement^="bottom"] > #arrow[data-v-20b7fd4a]::before {
    border-left: var(--popper-theme-border-width)
      var(--popper-theme-border-style) var(--popper-theme-border-color);
    border-top: var(--popper-theme-border-width)
      var(--popper-theme-border-style) var(--popper-theme-border-color);
}

  /* Left arrow */
.popper[data-popper-placement^="left"] > #arrow[data-v-20b7fd4a] {
    right: -5px;
}
.popper[data-popper-placement^="left"] > #arrow[data-v-20b7fd4a]::before {
    border-right: var(--popper-theme-border-width)
      var(--popper-theme-border-style) var(--popper-theme-border-color);
    border-top: var(--popper-theme-border-width)
      var(--popper-theme-border-style) var(--popper-theme-border-color);
}

  /* Right arrow */
.popper[data-popper-placement^="right"] > #arrow[data-v-20b7fd4a] {
    left: -5px;
}
`;
Vo(la);
const Nn = {};
Nn.render = aa;
Nn.__scopeId = "data-v-20b7fd4a";
var sa = Nn;
const ua = ["onKeyup"];
var Ho = {
  props: {
    /**
     * Preferred placement (the "auto" placements will choose the side with most space.)
     */
    placement: {
      type: String,
      default: "bottom",
      validator: function(t) {
        return ["auto", "auto-start", "auto-end", "top", "top-start", "top-end", "bottom", "bottom-start", "bottom-end", "right", "right-start", "right-end", "left", "left-start", "left-end"].includes(t);
      }
    },
    /**
     * Disables automatically closing the popover when the user clicks away from it
     */
    disableClickAway: {
      type: Boolean,
      default: !1
    },
    /**
     * Offset in pixels along the trigger element
     */
    offsetSkid: {
      type: String,
      default: "0"
    },
    /**
     * Offset in pixels away from the trigger element
     */
    offsetDistance: {
      type: String,
      default: "12"
    },
    /**
     * Trigger the popper on hover
     */
    hover: {
      type: Boolean,
      default: !1
    },
    /**
     * Manually open/close the Popper, other events are ignored if this prop is set
     */
    show: {
      type: Boolean,
      default: null
    },
    /**
     * Disables the Popper. If it was already open, it will be closed.
     */
    disabled: {
      type: Boolean,
      default: !1
    },
    /**
     * Open the Popper after a delay (ms).
     */
    openDelay: {
      type: [Number, String],
      default: 0
    },
    /**
     * Close the Popper after a delay (ms).
     */
    closeDelay: {
      type: [Number, String],
      default: 0
    },
    /**
     * The z-index of the Popper.
     */
    zIndex: {
      type: [Number, String],
      default: 9999
    },
    /**
     * Display an arrow on the popper
     */
    arrow: {
      type: Boolean,
      default: !1
    },
    /**
     * Stop arrow from reaching the edge of the popper
     */
    arrowPadding: {
      type: String,
      default: "0"
    },
    /**
     * If the Popper should be interactive, it will close when clicked/hovered if false
     */
    interactive: {
      type: Boolean,
      default: !0
    },
    /**
     * Lock the Popper into place, it will not flip dynamically when it runs out of space if true
     */
    locked: {
      type: Boolean,
      default: !1
    },
    /**
     * If the content is just a simple string, it can be passed in as a prop
     */
    content: {
      type: String,
      default: null
    }
  },
  emits: ["open:popper", "close:popper"],
  setup(t, {
    emit: e
  }) {
    const n = t;
    qo((U) => ({
      c81fc0a4: t.zIndex
    }));
    const o = Go(), r = ue(null), i = ue(null), a = ue(null), l = ue(!1);
    yt(() => {
      const U = o.default();
      if (U && U.length > 1)
        return console.error(`[Popper]: The <Popper> component expects only one child element at its root. You passed ${U.length} child nodes.`);
    });
    const {
      arrowPadding: s,
      closeDelay: c,
      content: d,
      disableClickAway: u,
      disabled: b,
      interactive: y,
      locked: h,
      offsetDistance: g,
      offsetSkid: f,
      openDelay: D,
      placement: x,
      show: w
    } = mo(n), {
      isOpen: T,
      open: S,
      close: F
    } = ra({
      arrowPadding: s,
      emit: e,
      locked: h,
      offsetDistance: g,
      offsetSkid: f,
      placement: x,
      popperNode: i,
      triggerNode: a
    }), {
      hasContent: m
    } = ei(o, i, d), C = z(() => w.value !== null), v = z(() => b.value || !m.value), E = z(() => T.value && !v.value), O = z(() => !u.value && !C.value), V = z(() => y.value ? `border: ${g.value}px solid transparent; margin: -${g.value}px;` : null), k = pn.debounce(S, D.value), H = pn.debounce(F, c.value), ie = async () => {
      v.value || C.value || (H.clear(), k());
    }, W = async () => {
      C.value || (k.clear(), H());
    }, le = () => {
      T.value ? W() : ie();
    };
    return vt([m, b], ([U, J]) => {
      T.value && (!U || J) && F();
    }), vt(T, (U) => {
      U ? l.value = !0 : pn.debounce(() => {
        l.value = !1;
      }, 200);
    }), qn(() => {
      C.value && (w.value ? k() : H());
    }), qn(() => {
      O.value && Zr(r, W);
    }), (U, J) => (I(), M("div", {
      class: "inline-block",
      style: Re(ee(V)),
      onMouseleave: J[2] || (J[2] = (K) => t.hover && W()),
      ref: (K, ve) => {
        ve.popperContainerNode = K, r.value = K;
      }
    }, [p("div", {
      ref: (K, ve) => {
        ve.triggerNode = K, a.value = K;
      },
      onMouseover: J[0] || (J[0] = (K) => t.hover && ie()),
      onClick: le,
      onFocus: ie,
      onKeyup: Jo(W, ["esc"])
    }, [gn(U.$slots, "default")], 40, ua), ze(Ko, {
      name: "fade"
    }, {
      default: It(() => [fe(p("div", {
        onClick: J[1] || (J[1] = (K) => !ee(y) && W()),
        class: "popper",
        ref: (K, ve) => {
          ve.popperNode = K, i.value = K;
        }
      }, [gn(U.$slots, "content", {
        close: ee(F),
        isOpen: l.value
      }, () => [lt(ge(ee(d)), 1)]), t.arrow ? (I(), Qo(sa, {
        key: 0
      })) : Vt("", !0)], 512), [[bo, ee(E)]])]),
      _: 3
    })], 36));
  }
}, ca = `
.inline-block[data-v-5784ed69] {
    display: inline-block;
}
.popper[data-v-5784ed69] {
    transition: background 250ms ease-in-out;
    background: var(--popper-theme-background-color);
    padding: var(--popper-theme-padding);
    color: var(--popper-theme-text-color);
    border-radius: var(--popper-theme-border-radius);
    border-width: var(--popper-theme-border-width);
    border-style: var(--popper-theme-border-style);
    border-color: var(--popper-theme-border-color);
    box-shadow: var(--popper-theme-box-shadow);
    z-index: var(--c81fc0a4);
}
.popper[data-v-5784ed69]:hover,
  .popper:hover > #arrow[data-v-5784ed69]::before {
    background: var(--popper-theme-background-color-hover);
}
.inline-block[data-v-5784ed69] {
    display: inline-block;
}
.fade-enter-active[data-v-5784ed69],
  .fade-leave-active[data-v-5784ed69] {
    transition: opacity 0.2s ease;
}
.fade-enter-from[data-v-5784ed69],
  .fade-leave-to[data-v-5784ed69] {
    opacity: 0;
}
`;
Vo(ca);
Ho.__scopeId = "data-v-5784ed69";
var da = /* @__PURE__ */ (() => {
  const t = Ho;
  return t.install = (e) => {
    e.component("Popper", t);
  }, t;
})();
const fa = (t) => {
  try {
    return JSON.parse(t);
  } catch {
    return null;
  }
}, pa = "data:image/svg+xml,%3csvg%20xmlns='http://www.w3.org/2000/svg'%20width='24'%20height='24'%20viewBox='0%200%2024%2024'%20fill='none'%20stroke='currentColor'%20stroke-width='2'%20stroke-linecap='round'%20stroke-linejoin='round'%20%3e%3cline%20x1='17'%20y1='10'%20x2='3'%20y2='10'%20/%3e%3cline%20x1='21'%20y1='6'%20x2='3'%20y2='6'%20/%3e%3cline%20x1='21'%20y1='14'%20x2='3'%20y2='14'%20/%3e%3cline%20x1='17'%20y1='18'%20x2='3'%20y2='18'%20/%3e%3c/svg%3e", va = "data:image/svg+xml,%3csvg%20xmlns='http://www.w3.org/2000/svg'%20xml:space='preserve'%20width='96'%20height='96'%3e%3cpath%20d='M12%2028h72a4%204%200%200%200%200-8H12a4%204%200%200%200%200%208zm8%208a4%204%200%200%200%200%208h56a4%204%200%200%200%200-8H20zm64%2016H12a4%204%200%200%200%200%208h72a4%204%200%200%200%200-8zm-8%2016H20a4%204%200%200%200%200%208h56a4%204%200%200%200%200-8z'/%3e%3c/svg%3e", ha = "data:image/svg+xml,%3csvg%20xmlns='http://www.w3.org/2000/svg'%20xml:space='preserve'%20width='96'%20height='96'%3e%3cpath%20d='M88%2024a4%204%200%200%200-4-4H12a4%204%200%200%200%200%208h72a4%204%200%200%200%204-4zm0%2016a4%204%200%200%200-4-4H28a4%204%200%200%200%200%208h56a4%204%200%200%200%204-4zM8%2056a4%204%200%200%200%204%204h72a4%204%200%200%200%200-8H12a4%204%200%200%200-4%204zm16%2016a4%204%200%200%200%204%204h56a4%204%200%200%200%200-8H28a4%204%200%200%200-4%204z'/%3e%3c/svg%3e", ga = "data:image/svg+xml,%3csvg%20xmlns='http://www.w3.org/2000/svg'%20width='24'%20height='24'%20viewBox='0%200%2024%2024'%3e%3cpath%20d='M8%2011h3v10h2V11h3l-4-4-4%204zM4%203v2h16V3H4z'/%3e%3c/svg%3e", ma = "data:image/svg+xml,%3csvg%20xmlns='http://www.w3.org/2000/svg'%20width='24'%20height='24'%20viewBox='0%200%2024%2024'%3e%3cpath%20d='M8%2019h3v4h2v-4h3l-4-4-4%204zm8-14h-3V1h-2v4H8l4%204%204-4zM4%2011v2h16v-2H4z'/%3e%3c/svg%3e", ba = "data:image/svg+xml,%3csvg%20xmlns='http://www.w3.org/2000/svg'%20width='24'%20height='24'%20viewBox='0%200%2024%2024'%3e%3cpath%20d='M16%2013h-3V3h-2v10H8l4%204%204-4zM4%2019v2h16v-2H4z'/%3e%3c/svg%3e", Q = [];
for (let t = 0; t < 256; ++t)
  Q.push((t + 256).toString(16).slice(1));
function ya(t, e = 0) {
  return (Q[t[e + 0]] + Q[t[e + 1]] + Q[t[e + 2]] + Q[t[e + 3]] + "-" + Q[t[e + 4]] + Q[t[e + 5]] + "-" + Q[t[e + 6]] + Q[t[e + 7]] + "-" + Q[t[e + 8]] + Q[t[e + 9]] + "-" + Q[t[e + 10]] + Q[t[e + 11]] + Q[t[e + 12]] + Q[t[e + 13]] + Q[t[e + 14]] + Q[t[e + 15]]).toLowerCase();
}
let hn;
const wa = new Uint8Array(16);
function _a() {
  if (!hn) {
    if (typeof crypto > "u" || !crypto.getRandomValues)
      throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");
    hn = crypto.getRandomValues.bind(crypto);
  }
  return hn(wa);
}
const Ta = typeof crypto < "u" && crypto.randomUUID && crypto.randomUUID.bind(crypto), go = { randomUUID: Ta };
function Wo(t, e, n) {
  var r;
  if (go.randomUUID && !e && !t)
    return go.randomUUID();
  t = t || {};
  const o = t.random ?? ((r = t.rng) == null ? void 0 : r.call(t)) ?? _a();
  if (o.length < 16)
    throw new Error("Random bytes length must be >= 16");
  if (o[6] = o[6] & 15 | 64, o[8] = o[8] & 63 | 128, e) {
    if (n = n || 0, n < 0 || n + 16 > e.length)
      throw new RangeError(`UUID byte range ${n}:${n + 15} is out of buffer bounds`);
    for (let i = 0; i < 16; ++i)
      e[n + i] = o[i];
    return e;
  }
  return ya(o);
}
const Dt = (t) => (xn("data-v-f7365bfd"), t = t(), Sn(), t), Ca = {
  key: 0,
  class: "popup-edit-label"
}, Da = { class: "popup-content" }, Ea = { class: "input-group" }, xa = /* @__PURE__ */ Dt(() => /* @__PURE__ */ p("label", null, "Tiêu đề:", -1)), Sa = {
  key: 0,
  class: "input-group presets-section"
}, Oa = /* @__PURE__ */ Dt(() => /* @__PURE__ */ p("label", null, "Mẫu có sẵn:", -1)), Aa = { class: "presets-list" }, ka = ["onClick"], Fa = { class: "input-group" }, $a = /* @__PURE__ */ Dt(() => /* @__PURE__ */ p("label", null, "Màu chữ:", -1)), La = { class: "color-picker" }, Ia = { class: "color-input-group" }, Ma = { class: "quick-colors" }, Pa = ["onClick"], Ba = { class: "input-group" }, Na = /* @__PURE__ */ Dt(() => /* @__PURE__ */ p("label", null, "Màu nền:", -1)), Ra = { class: "color-picker" }, Ya = { class: "color-input-group" }, ja = { class: "quick-colors" }, Va = ["onClick"], Ha = { class: "input-group" }, Wa = /* @__PURE__ */ Dt(() => /* @__PURE__ */ p("label", null, "Style:", -1)), Ua = { class: "style-buttons" }, za = { class: "actions" }, Xa = ["disabled"], qa = /* @__PURE__ */ bt({
  __name: "PopupEditLabel",
  props: {
    presets: { default: () => [] }
  },
  emits: ["save"],
  setup(t, { expose: e, emit: n }) {
    const o = n, r = ue(), i = ue(!1), a = ue({
      title: "",
      code: "",
      style: {
        color: "#000000",
        backgroundColor: "#ffffff",
        fontWeight: "normal",
        fontStyle: "normal",
        textDecoration: "none"
      }
    }), l = [
      "#000000",
      "#999999",
      "#ffffff",
      "#ff0000",
      "#00ff00",
      "#0000ff",
      "#ffff00",
      "#ff00ff",
      "#00ffff",
      "#ffa500",
      "#800080"
    ], s = [
      "#000000",
      "#ffffff",
      "#ff0000",
      "#00ff00",
      "#0000ff",
      "#ffff00",
      "#ff00ff",
      "#00ffff",
      "#ffa500",
      "#800080",
      "transparent"
    ], c = (h) => {
      if (a.value.style)
        switch (h) {
          case "fontWeight":
            a.value.style.fontWeight = a.value.style.fontWeight === "bold" ? "normal" : "bold";
            break;
          case "fontStyle":
            a.value.style.fontStyle = a.value.style.fontStyle === "italic" ? "normal" : "italic";
            break;
          case "textDecoration":
            a.value.style.textDecoration = a.value.style.textDecoration === "underline" ? "none" : "underline";
            break;
        }
    }, d = () => {
      i.value = !1;
    }, u = () => {
      o("save", a.value), i.value = !1;
    }, b = (h) => {
      var g, f, D, x, w;
      i.value = !0, h ? a.value = {
        title: h.title,
        code: h.code,
        style: {
          color: ((g = h.style) == null ? void 0 : g.color) || "#000000",
          backgroundColor: ((f = h.style) == null ? void 0 : f.backgroundColor) || "transparent",
          fontWeight: ((D = h.style) == null ? void 0 : D.fontWeight) || "normal",
          fontStyle: ((x = h.style) == null ? void 0 : x.fontStyle) || "normal",
          textDecoration: ((w = h.style) == null ? void 0 : w.textDecoration) || "none"
        }
      } : a.value = {
        title: "",
        code: Wo(),
        style: {
          color: "#000000",
          backgroundColor: "transparent",
          fontWeight: "normal",
          fontStyle: "normal",
          textDecoration: "none"
        }
      }, yo(() => {
        var T;
        (T = r.value) == null || T.focus();
      });
    }, y = (h) => {
      a.value.style && (a.value.style = { ...h.style });
    };
    return e({
      show: b
    }), (h, g) => i.value ? (I(), M("div", Ca, [
      p("div", Da, [
        p("div", Ea, [
          xa,
          fe(p("input", {
            ref_key: "inputTitleRef",
            ref: r,
            class: "input-title",
            "onUpdate:modelValue": g[0] || (g[0] = (f) => a.value.title = f),
            type: "text",
            placeholder: "Nhập tiêu đề..."
          }, null, 512), [
            [ke, a.value.title]
          ])
        ]),
        h.presets && h.presets.length > 0 ? (I(), M("div", Sa, [
          Oa,
          p("div", Aa, [
            (I(!0), M(te, null, ne(h.presets, (f) => (I(), M("span", {
              key: f.name,
              class: "preset-item",
              onClick: (D) => y(f)
            }, [
              p("span", {
                class: "preset-preview",
                style: Re({
                  color: f.style.color,
                  backgroundColor: f.style.backgroundColor,
                  fontWeight: f.style.fontWeight,
                  fontStyle: f.style.fontStyle,
                  textDecoration: f.style.textDecoration
                })
              }, ge(f.name), 5)
            ], 8, ka))), 128))
          ])
        ])) : Vt("", !0),
        p("div", Fa, [
          $a,
          p("div", La, [
            p("div", Ia, [
              fe(p("input", {
                "onUpdate:modelValue": g[1] || (g[1] = (f) => a.value.style.color = f),
                type: "color"
              }, null, 512), [
                [ke, a.value.style.color]
              ]),
              fe(p("input", {
                "onUpdate:modelValue": g[2] || (g[2] = (f) => a.value.style.color = f),
                type: "text",
                class: "hex-input",
                placeholder: "#000000"
              }, null, 512), [
                [ke, a.value.style.color]
              ])
            ]),
            p("div", Ma, [
              (I(), M(te, null, ne(l, (f) => p("button", {
                key: f,
                style: Re({ backgroundColor: f }),
                onClick: (D) => a.value.style.color = f
              }, null, 12, Pa)), 64))
            ])
          ])
        ]),
        p("div", Ba, [
          Na,
          p("div", Ra, [
            p("div", Ya, [
              fe(p("input", {
                "onUpdate:modelValue": g[3] || (g[3] = (f) => a.value.style.backgroundColor = f),
                type: "color"
              }, null, 512), [
                [ke, a.value.style.backgroundColor]
              ]),
              fe(p("input", {
                "onUpdate:modelValue": g[4] || (g[4] = (f) => a.value.style.backgroundColor = f),
                type: "text",
                class: "hex-input",
                placeholder: "#ffffff"
              }, null, 512), [
                [ke, a.value.style.backgroundColor]
              ])
            ]),
            p("div", ja, [
              (I(), M(te, null, ne(s, (f) => p("button", {
                key: f,
                style: Re({ backgroundColor: f }),
                onClick: (D) => a.value.style.backgroundColor = f
              }, null, 12, Va)), 64))
            ])
          ])
        ]),
        p("div", Ha, [
          Wa,
          p("div", Ua, [
            p("button", {
              class: q({ active: a.value.style.fontWeight === "bold" }),
              onClick: g[5] || (g[5] = (f) => c("fontWeight"))
            }, " B ", 2),
            p("button", {
              class: q({ active: a.value.style.fontStyle === "italic" }),
              onClick: g[6] || (g[6] = (f) => c("fontStyle"))
            }, " I ", 2),
            p("button", {
              class: q({ active: a.value.style.textDecoration === "underline" }),
              onClick: g[7] || (g[7] = (f) => c("textDecoration"))
            }, " U ", 2)
          ])
        ]),
        p("div", za, [
          p("button", {
            class: "btn-cancel",
            onClick: d
          }, "Hủy"),
          p("button", {
            class: "btn-save",
            onClick: u,
            disabled: !a.value.title
          }, "Lưu", 8, Xa)
        ])
      ])
    ])) : Vt("", !0);
  }
}), Ga = /* @__PURE__ */ Gt(qa, [["__scopeId", "data-v-f7365bfd"]]), re = (t) => (xn("data-v-5f0c036e"), t = t(), Sn(), t), Ja = { class: "grid-col-2" }, Ka = { class: "edit-columns" }, Qa = { class: "justify-content-space-between" }, Za = /* @__PURE__ */ re(() => /* @__PURE__ */ p("h5", null, " Columns ", -1)), el = ["disabled"], tl = /* @__PURE__ */ re(() => /* @__PURE__ */ p("hr", { style: { margin: "5px 0" } }, null, -1)), nl = ["onClick"], ol = ["onDrop", "onDragover", "onDragleave"], rl = { class: "align-items-center" }, il = /* @__PURE__ */ re(() => /* @__PURE__ */ p("span", { class: "handle" }, "☰", -1)), al = ["disabled"], ll = { class: "popover-action" }, sl = ["onClick"], ul = ["src"], cl = ["onClick"], dl = ["src"], fl = ["onClick"], pl = ["src"], vl = { style: { "margin-top": "4px" } }, hl = ["onClick"], gl = ["src"], ml = ["onClick"], bl = ["src"], yl = ["onClick"], wl = ["src"], _l = {
  style: { "margin-top": "4px" },
  class: "div-input"
}, Tl = /* @__PURE__ */ re(() => /* @__PURE__ */ p("label", { class: "label" }, "width:", -1)), Cl = ["onUpdate:modelValue"], Dl = {
  style: { "margin-top": "4px" },
  class: "div-input"
}, El = /* @__PURE__ */ re(() => /* @__PURE__ */ p("label", { class: "label" }, "min-width:", -1)), xl = ["onUpdate:modelValue"], Sl = {
  style: { "margin-top": "4px" },
  class: "div-input"
}, Ol = /* @__PURE__ */ re(() => /* @__PURE__ */ p("label", { class: "label" }, "max-width:", -1)), Al = ["onUpdate:modelValue"], kl = ["disabled", "onUpdate:modelValue"], Fl = { class: "list-selected-field" }, $l = ["src"], Ll = { key: 1 }, Il = { class: "no-data" }, Ml = ["onClick", "disabled"], Pl = { class: "edit-columns" }, Bl = /* @__PURE__ */ re(() => /* @__PURE__ */ p("h5", null, "Fields", -1)), Nl = /* @__PURE__ */ re(() => /* @__PURE__ */ p("hr", { style: { margin: "5px 0" } }, null, -1)), Rl = { class: "list-field custom-scroll" }, Yl = { class: "label" }, jl = ["onDragstart", "onDblclick"], Vl = { class: "edit-columns etc-field custom-scroll" }, Hl = { class: "justify-content-space-between" }, Wl = /* @__PURE__ */ re(() => /* @__PURE__ */ p("h5", null, " Labels ", -1)), Ul = ["disabled"], zl = /* @__PURE__ */ re(() => /* @__PURE__ */ p("hr", { style: { margin: "5px 0" } }, null, -1)), Xl = { class: "list-field-symbol" }, ql = ["onClick", "onDblclick", "onDragstart"], Gl = { style: { "margin-top": "10px" } }, Jl = /* @__PURE__ */ re(() => /* @__PURE__ */ p("h5", null, "Actions", -1)), Kl = /* @__PURE__ */ re(() => /* @__PURE__ */ p("hr", { style: { margin: "5px 0" } }, null, -1)), Ql = { class: "list-field-symbol" }, Zl = ["onDblclick", "onDragstart"], es = { style: { "margin-top": "10px" } }, ts = /* @__PURE__ */ re(() => /* @__PURE__ */ p("h5", null, "Separator", -1)), ns = /* @__PURE__ */ re(() => /* @__PURE__ */ p("hr", { style: { margin: "5px 0" } }, null, -1)), os = { class: "list-field-symbol" }, rs = ["onDblclick", "onDragstart"], is = { style: { "margin-top": "10px" } }, as = /* @__PURE__ */ re(() => /* @__PURE__ */ p("h5", null, "Icons", -1)), ls = /* @__PURE__ */ re(() => /* @__PURE__ */ p("hr", { style: { margin: "5px 0" } }, null, -1)), ss = { class: "list-field-symbol" }, us = ["onDblclick", "src", "onDragstart"], cs = /* @__PURE__ */ bt({
  __name: "TableEditor",
  props: {
    modelValue: {},
    labels: { default: () => [] },
    vfFields: { default: () => [] },
    actions: { default: () => [] },
    icons: { default: () => [] },
    height: { default: 390 },
    disabled: { type: Boolean, default: !1 },
    labelPresets: { default: () => [] }
  },
  emits: ["update:modelValue", "update:labels", "error"],
  setup(t, { emit: e }) {
    const n = t, o = e, r = z({
      get() {
        return n.modelValue;
      },
      set(m) {
        o("update:modelValue", m);
      }
    }), i = z({
      get() {
        return n.labels || [];
      },
      set(m) {
        o("update:labels", m);
      }
    }), a = z(() => i.value.map((m) => ({
      vfCode: m.code,
      vfTitle: m.title,
      vfType: A.LABEL,
      vfAcutalField: m.code,
      vfActualFieldTitle: m.title
    }))), l = z(() => [...mn, ...n.actions, ...n.icons, ...n.vfFields, ...a.value]), s = z(() => l.value.reduce((m, C) => (m[C.vfCode] = C, m), {})), c = ue(-1), d = z(() => {
      const m = {}, C = [];
      for (const v of n.vfFields) {
        const E = (v == null ? void 0 : v.vfAcutalField) || "";
        m[E] === void 0 ? (C.push({
          title: v.vfActualFieldTitle || "",
          field: E,
          variants: [v]
        }), m[E] = C.length - 1) : C[m[E]].variants.push(v);
      }
      return C;
    }), u = () => {
      o("update:modelValue", [
        ...n.modelValue,
        {
          title: "",
          fieldCodes: [],
          isDrag: !1
        }
      ]);
    }, b = (m, C) => {
      m.dataTransfer.setData("text", JSON.stringify(C));
    }, y = (m, C) => {
      if (n.disabled)
        return !1;
      m.preventDefault(), C.isDrag = !0;
    }, h = (m, C) => {
      if (n.disabled)
        return !1;
      m.preventDefault(), C.isDrag = !1;
    }, g = (m, C, v) => {
      if (n.disabled)
        return !1;
      m.preventDefault();
      const E = fa(m.dataTransfer.getData("text"));
      E && E.vfCode && C.fieldCodes.push(E.vfCode), C.isDrag = !1, c.value = v;
    }, f = (m) => {
      const C = n.modelValue, v = C[m];
      v.fieldCodes.length > 0 ? v.fieldCodes.pop() : (C.splice(m, 1), c.value = -1), o("update:modelValue", C);
    }, D = (m) => {
      if (!n.disabled)
        if (c.value >= 0) {
          const C = r.value[c.value];
          C && C.fieldCodes.push(m.vfCode);
        } else
          o("error", "Hãy chọn column để thêm");
    }, x = ue(), w = z(() => (m) => {
      const C = i.value.find((v) => v.code === m.vfCode);
      return (C == null ? void 0 : C.style) || {};
    }), T = () => {
      var m;
      (m = x.value) == null || m.show();
    }, S = (m) => {
      var v;
      const C = i.value.find((E) => E.code === m.vfCode);
      C && ((v = x.value) == null || v.show(C));
    }, F = (m) => {
      console.log("handleSaveLabel", m);
      const C = i.value.find((v) => v.code === m.code);
      C ? (C.title = m.title, C.style = m.style) : i.value.push(m), o("update:labels", i.value);
    };
    return (m, C) => (I(), M("div", {
      class: "dynamic-table-edit box box-grid",
      style: Re({ height: `${m.height}px` })
    }, [
      p("div", Ja, [
        p("div", Ka, [
          p("div", Qa, [
            Za,
            p("div", null, [
              p("button", {
                class: "btn-plus",
                disabled: m.disabled,
                onClick: u
              }, "✚", 8, el)
            ])
          ]),
          tl,
          ze(ee(Kr), {
            tag: "ul",
            modelValue: r.value,
            "onUpdate:modelValue": C[0] || (C[0] = (v) => r.value = v),
            handle: ".handle",
            "ghost-class": "ghost",
            sort: !m.disabled,
            class: "dragArea list-group custom-scroll"
          }, {
            default: It(() => [
              (I(!0), M(te, null, ne(r.value, (v, E) => (I(), M("li", {
                key: E,
                class: q(["list-group-item", { hover: v.isDrag, active: c.value === E }]),
                onClick: (O) => !m.disabled && (c.value = E)
              }, [
                p("div", {
                  class: "label align-items-center",
                  onDrop: (O) => g(O, v, E),
                  onDragover: (O) => y(O, v),
                  onDragleave: (O) => h(O, v)
                }, [
                  p("div", rl, [
                    il,
                    ze(ee(da), {
                      placement: "right-start",
                      arrow: "",
                      class: "popper-wrapper"
                    }, {
                      content: It(() => [
                        p("div", ll, [
                          p("div", null, [
                            p("button", {
                              class: q(["btn-more", { active: (v.align || "left") === "left" }]),
                              onClick: (O) => v.align = "left"
                            }, [
                              p("img", { src: ee(pa) }, null, 8, ul)
                            ], 10, sl),
                            p("button", {
                              class: q(["btn-more", { active: v.align === "center" }]),
                              onClick: (O) => v.align = "center"
                            }, [
                              p("img", { src: ee(va) }, null, 8, dl)
                            ], 10, cl),
                            p("button", {
                              class: q(["btn-more", { active: v.align === "right" }]),
                              onClick: (O) => v.align = "right"
                            }, [
                              p("img", { src: ee(ha) }, null, 8, pl)
                            ], 10, fl)
                          ]),
                          p("div", vl, [
                            p("button", {
                              class: q(["btn-more", { active: (v.vAlign || "top") === "top" }]),
                              onClick: (O) => v.vAlign = "top"
                            }, [
                              p("img", { src: ee(ga) }, null, 8, gl)
                            ], 10, hl),
                            p("button", {
                              class: q(["btn-more", { active: v.vAlign === "middle" }]),
                              onClick: (O) => v.vAlign = "middle"
                            }, [
                              p("img", { src: ee(ma) }, null, 8, bl)
                            ], 10, ml),
                            p("button", {
                              class: q(["btn-more", { active: v.vAlign === "bottom" }]),
                              onClick: (O) => v.vAlign = "bottom"
                            }, [
                              p("img", { src: ee(ba) }, null, 8, wl)
                            ], 10, yl)
                          ]),
                          p("div", _l, [
                            Tl,
                            lt(),
                            fe(p("input", {
                              type: "text",
                              "onUpdate:modelValue": (O) => v.width = O,
                              placeholder: "# px | %"
                            }, null, 8, Cl), [
                              [ke, v.width]
                            ])
                          ]),
                          p("div", Dl, [
                            El,
                            lt(),
                            fe(p("input", {
                              type: "text",
                              "onUpdate:modelValue": (O) => v.minWidth = O,
                              placeholder: "# px | %"
                            }, null, 8, xl), [
                              [ke, v.minWidth]
                            ])
                          ]),
                          p("div", Sl, [
                            Ol,
                            lt(),
                            fe(p("input", {
                              type: "text",
                              "onUpdate:modelValue": (O) => v.maxWidth = O,
                              placeholder: "# px | %"
                            }, null, 8, Al), [
                              [ke, v.maxWidth]
                            ])
                          ])
                        ])
                      ]),
                      default: It(() => [
                        p("button", {
                          class: "btn-more",
                          disabled: m.disabled
                        }, "⋯", 8, al)
                      ]),
                      _: 2
                    }, 1024),
                    fe(p("input", {
                      disabled: m.disabled,
                      class: "input-title",
                      type: "text",
                      "onUpdate:modelValue": (O) => v.title = O,
                      placeholder: "Column name"
                    }, null, 8, kl), [
                      [ke, v.title]
                    ])
                  ]),
                  p("ul", Fl, [
                    (I(!0), M(te, null, ne(v.fieldCodes, (O) => {
                      var V, k, H;
                      return I(), M("li", { key: O }, [
                        ((V = s.value[O]) == null ? void 0 : V.vfType) === ee(A).ICON ? (I(), M("img", {
                          key: 0,
                          class: "icon-selected",
                          src: (k = s.value[O]) == null ? void 0 : k.value
                        }, null, 8, $l)) : (I(), M("span", Ll, ge((H = s.value[O]) == null ? void 0 : H.vfTitle), 1))
                      ]);
                    }), 128)),
                    fe(p("li", Il, "Kéo field vào đây", 512), [
                      [bo, !v.fieldCodes.length]
                    ])
                  ])
                ], 40, ol),
                p("div", null, [
                  p("button", {
                    class: "btn btn-close",
                    onClick: tr((O) => f(E), ["stop"]),
                    disabled: m.disabled
                  }, " ✘ ", 8, Ml)
                ])
              ], 10, nl))), 128))
            ]),
            _: 1
          }, 8, ["modelValue", "sort"])
        ]),
        p("div", Pl, [
          Bl,
          Nl,
          p("ul", Rl, [
            (I(!0), M(te, null, ne(d.value, (v) => (I(), M("li", {
              key: v.field
            }, [
              p("div", Yl, ge(v.title) + ":", 1),
              (I(!0), M(te, null, ne(v.variants, (E) => (I(), M("div", {
                class: q(["item", { disabled: m.disabled }]),
                draggable: "true",
                onDragstart: (O) => b(O, E),
                key: E.vfCode,
                onDblclick: (O) => D(E)
              }, ge(E.vfTitle), 43, jl))), 128))
            ]))), 128))
          ])
        ]),
        p("div", Vl, [
          p("div", null, [
            p("div", Hl, [
              Wl,
              p("div", null, [
                p("button", {
                  class: "btn-plus",
                  disabled: m.disabled,
                  onClick: T
                }, "✚", 8, Ul)
              ])
            ]),
            zl,
            p("ul", Xl, [
              (I(!0), M(te, null, ne(a.value, (v) => (I(), M("li", {
                key: v.vfCode
              }, [
                p("div", {
                  onClick: (E) => !m.disabled && S(v),
                  style: Re(w.value(v)),
                  onDblclick: (E) => D(v),
                  class: q(["item btn", { disabled: m.disabled }]),
                  draggable: "true",
                  onDragstart: (E) => b(E, v)
                }, ge(v.vfTitle), 47, ql)
              ]))), 128))
            ])
          ]),
          p("div", Gl, [
            Jl,
            Kl,
            p("ul", Ql, [
              (I(!0), M(te, null, ne(m.actions, (v) => (I(), M("li", {
                key: v.vfAcutalField
              }, [
                p("div", {
                  onDblclick: (E) => D(v),
                  class: q(["item btn", { disabled: m.disabled }]),
                  draggable: "true",
                  onDragstart: (E) => b(E, v)
                }, ge(v.vfTitle), 43, Zl)
              ]))), 128))
            ])
          ]),
          p("div", es, [
            ts,
            ns,
            p("ul", os, [
              (I(!0), M(te, null, ne(ee(mn), (v) => (I(), M("li", {
                key: v.vfAcutalField
              }, [
                p("div", {
                  onDblclick: (E) => D(v),
                  class: q(["item", { disabled: m.disabled }]),
                  draggable: "true",
                  onDragstart: (E) => b(E, v)
                }, ge(v.vfTitle), 43, rs)
              ]))), 128))
            ])
          ]),
          p("div", is, [
            as,
            ls,
            p("ul", ss, [
              (I(!0), M(te, null, ne(m.icons, (v) => (I(), M("li", {
                key: v.vfAcutalField
              }, [
                p("img", {
                  onDblclick: (E) => D(v),
                  src: v.value,
                  class: q(["icon", { disabled: m.disabled }]),
                  draggable: "true",
                  onDragstart: (E) => b(E, v)
                }, null, 42, us)
              ]))), 128))
            ])
          ])
        ])
      ]),
      ze(Ga, {
        ref_key: "popupEditLabelRef",
        ref: x,
        presets: m.labelPresets,
        onSave: F
      }, null, 8, ["presets"])
    ], 4));
  }
}), ds = /* @__PURE__ */ Gt(cs, [["__scopeId", "data-v-5f0c036e"]]), Rn = (t) => (xn("data-v-9bcac759"), t = t(), Sn(), t), fs = { class: "flexi-table" }, ps = { class: "table-controls" }, vs = { class: "layout-selector" }, hs = /* @__PURE__ */ Rn(() => /* @__PURE__ */ p("h4", null, "Layout: ", -1)), gs = { class: "dropdown" }, ms = ["value"], bs = { class: "quick-layouts" }, ys = ["onClick"], ws = {
  key: 0,
  class: "editor-popup"
}, _s = { class: "editor-content" }, Ts = { class: "editor-header" }, Cs = /* @__PURE__ */ Rn(() => /* @__PURE__ */ p("h3", null, "Tùy chỉnh bảng", -1)), Ds = { class: "editor-body" }, Es = { class: "editor-actions" }, xs = /* @__PURE__ */ Rn(() => /* @__PURE__ */ p("h4", null, "Layout:", -1)), Ss = { class: "dropdown" }, Os = ["value"], As = ["disabled"], ks = ["disabled"], Fs = ["disabled"], $s = /* @__PURE__ */ bt({
  __name: "FlexiTable",
  props: {
    modelValue: {},
    layouts: { default: () => [] },
    templates: { default: () => [] },
    actions: { default: () => [] },
    icons: { default: () => [] },
    data: { default: () => [] },
    height: {},
    fixed: { type: Boolean },
    labelPresets: { default: () => [] }
  },
  emits: ["update:modelValue", "onCta", "error", "save", "remove", "setDefault"],
  setup(t, { emit: e }) {
    const n = t, o = e, r = ue(!1), i = z({
      get() {
        return n.modelValue;
      },
      set(w) {
        o("update:modelValue", w);
      }
    }), a = z(() => n.layouts.find((w) => w.id === i.value)), l = (w) => {
      o("error", w);
    }, s = (w, T, S) => {
      o("onCta", w, T, S);
    }, c = ue([]), d = ue(""), u = z(() => c.value.find((w) => w.id === d.value)), b = z({
      get() {
        var w;
        return ((w = u.value) == null ? void 0 : w.columns) || [];
      },
      set(w) {
        u.value.columns = w;
      }
    }), y = () => {
      r.value = !0, d.value = i.value, c.value = JSON.parse(JSON.stringify(n.layouts || [])).map((w) => ({
        ...w,
        isSave: !0
      }));
    }, h = () => {
    }, g = () => {
      var S;
      const w = Wo(), T = {
        ...JSON.parse(JSON.stringify(u.value)),
        isSave: !1,
        isSystem: !1,
        isDefault: !1,
        id: w,
        title: `${((S = u.value) == null ? void 0 : S.title) || ""} clone`
      };
      c.value.push(T), d.value = w;
    }, f = () => {
      var S;
      const w = d.value, T = () => {
        const F = c.value.findIndex((m) => m.id === w);
        c.value.splice(F, 1), d.value = c.value[0].id || "";
      };
      (S = u.value) != null && S.isSave ? o("remove", w, () => {
        T();
      }) : T();
    }, D = () => {
      const w = JSON.parse(JSON.stringify(u.value));
      delete w.isSave, o("save", w, () => {
        u.value && (u.value.isSave = !0);
      });
    }, x = () => {
      o("setDefault", d.value, () => {
      });
    };
    return yt(() => {
    }), (w, T) => {
      var S, F, m, C, v, E, O, V;
      return I(), M("div", fs, [
        p("div", ps, [
          p("div", vs, [
            hs,
            p("div", gs, [
              fe(p("select", {
                "onUpdate:modelValue": T[0] || (T[0] = (k) => i.value = k)
              }, [
                (I(!0), M(te, null, ne(w.layouts, (k) => (I(), M("option", {
                  key: k.id,
                  value: k.id
                }, ge(k.title), 9, ms))), 128))
              ], 512), [
                [Gn, i.value]
              ])
            ]),
            p("div", bs, [
              (I(!0), M(te, null, ne(w.layouts, (k) => (I(), M("button", {
                key: k.id,
                onClick: (H) => i.value = k.id,
                class: q({ active: i.value === k.id })
              }, ge(k.title), 11, ys))), 128))
            ])
          ]),
          p("div", { class: "settings" }, [
            p("button", { onClick: y }, " ⚙️ ")
          ])
        ]),
        ze(Jn, {
          columns: ((S = a.value) == null ? void 0 : S.columns) || [],
          labels: ((F = a.value) == null ? void 0 : F.labels) || [],
          templates: [...w.templates, ...w.actions, ...w.icons],
          data: w.data,
          height: w.height,
          fixed: w.fixed,
          onOnCta: s
        }, null, 8, ["columns", "labels", "templates", "data", "height", "fixed"]),
        r.value ? (I(), M("div", ws, [
          p("div", {
            class: "editor-overlay",
            onClick: T[1] || (T[1] = (k) => r.value = !1)
          }),
          p("div", _s, [
            p("div", Ts, [
              Cs,
              p("button", {
                onClick: T[2] || (T[2] = (k) => r.value = !1)
              }, "✕")
            ]),
            p("div", Ds, [
              ze(Jn, {
                columns: b.value,
                labels: ((m = u.value) == null ? void 0 : m.labels) || [],
                templates: [...w.templates, ...w.actions, ...w.icons],
                data: w.data,
                height: 250,
                fixed: !0
              }, null, 8, ["columns", "labels", "templates", "data"]),
              p("div", Es, [
                xs,
                p("div", Ss, [
                  fe(p("select", {
                    "onUpdate:modelValue": T[3] || (T[3] = (k) => d.value = k),
                    onChange: h
                  }, [
                    (I(!0), M(te, null, ne(c.value, (k) => (I(), M("option", {
                      key: k.id,
                      value: k.id
                    }, ge(k.title), 9, Os))), 128))
                  ], 544), [
                    [Gn, d.value]
                  ])
                ]),
                p("button", { onClick: g }, " Clone "),
                p("button", {
                  disabled: (C = u.value) == null ? void 0 : C.isSystem,
                  onClick: f
                }, " Xóa ", 8, As),
                p("button", {
                  disabled: (v = u.value) == null ? void 0 : v.isSystem,
                  onClick: D
                }, " Lưu ", 8, ks),
                p("button", {
                  disabled: !((E = u.value) != null && E.isSave) || ((O = u.value) == null ? void 0 : O.id) === i.value,
                  onClick: x
                }, " Default ", 8, Fs)
              ]),
              ze(ds, {
                modelValue: b.value,
                "onUpdate:modelValue": T[4] || (T[4] = (k) => b.value = k),
                labels: u.value.labels,
                "onUpdate:labels": T[5] || (T[5] = (k) => u.value.labels = k),
                "vf-fields": w.templates,
                actions: w.actions,
                icons: w.icons,
                height: 450,
                disabled: (V = u.value) == null ? void 0 : V.isSystem,
                "label-presets": w.labelPresets,
                onError: l
              }, null, 8, ["modelValue", "labels", "vf-fields", "actions", "icons", "disabled", "label-presets"])
            ])
          ])
        ])) : Vt("", !0)
      ]);
    };
  }
}), Is = /* @__PURE__ */ Gt($s, [["__scopeId", "data-v-9bcac759"]]);
export {
  Jn as DynamicTable,
  Is as FlexiTable,
  ds as TableEditor,
  A as VfType
};
