import { VfField, Column, VfType, LabelField, LayoutTemplate, VariantsField, LabelPreset } from './interfaces/table';
import { default as FlexiTable } from './components/FlexiTable.vue';
import { default as TableEditor } from './components/TableEditor.vue';
import { default as DynamicTable } from './components/DynamicTable.vue';

export type { VfField, Column, LayoutTemplate, LabelField, VariantsField, LabelPreset };
export { DynamicTable, TableEditor, FlexiTable, VfType };
